FTAP_Display = {};
FTAP_Display.modDir = g_currentModDirectory;

FTAP_Display.metadata = {
	interface = "FS25 ...", --convert ls22 to ls25
	title = "FillTypeAmountPrice Display",
	notes = "Zeigt in Echtzeit Aktuelle Preise und Bestände an (mit integrierten HL Hud System)",
	author = "(by HappyLooser)",
	version = "1.0.0.0",
	build = 10,
	xmlVersion = 1,
	languageVersion = 1,
	datum = "20.02.2024", 
	update = "24.12.2024",
	discord = "HappyLooser Modding",
	info = " Link Freigabe,Änderungen,Kopien oder Code Benutzung ist ohne meine Zustimmung nicht erlaubt"	
};

function FTAP_Display:loadMap(mapName)		
	print("---loading ".. tostring(FTAP_Display.metadata.title).. " ".. tostring(FTAP_Display.metadata.version).. "(#".. tostring(FTAP_Display.metadata.build).. ") ".. tostring(FTAP_Display.metadata.author).. "---")
	if not FTAP_Display:getDetiServer() then
		FTAP_Display:loadValues();
	end;
end;

function FTAP_Display:loadValues() --for All in Mod Extra Load
	if not FTAP_Display:getDetiServer() then
		FTAP_Display.hlDebugMode = false;	--for Modder Testing	
		FTAP_Display.testString = {};		
		generateFolders();
		FTAP_Display:loadSource(1);		
		FTAP_Display.loadError = false; --optional for !
		Mission00.onStartMission = Utils.appendedFunction(Mission00.onStartMission, FTAP_Display.onStartMission);		
	end;
end;

function FTAP_Display:onStartMission()
	if FTAP_Display:getDetiServer() then return;end;	
	g_currentMission.hlUtils.modLoad("FS25_FillTypeAmountPriceDisplay");
	FTAP_DisplaySetGet:setGlobalFunctions();
	FTAP_Display.lastPlayerFarmId = g_currentMission.hlUtils.getPlayerFarmId();	
	if g_currentMission.hlHudSystem ~= nil and g_currentMission.hlHudSystem.hlHud ~= nil and g_currentMission.hlHudSystem.hlHud.generate ~= nil then --check is HL Hud System ready !
		print("#Info: ".. tostring(FTAP_Display.metadata.title).. " generate Hud --> for HL Hud System (".. tostring(g_currentMission.hlHudSystem.metadata.version).. ")")
		local hud = g_currentMission.hlHudSystem.hlHud.generate( {name="FTAP_Display_Hud", width=40, info="FillTypeAmountPrice Display Mod\n(FTAP Display)", hiddenMod="FillTypeAmountPriceDisplay", ownTable={}} ); --loadDefaultIcons=true	
		if hud ~= nil then			
			g_currentMission.hlUtils.loadLanguage( {modTitle=tostring(FTAP_Display.metadata.title), class="FS25_FillTypeAmountPriceDisplay", modDir=FTAP_Display.modDir.. "scripte_ftap/", xmlDir="FS25_FillTypeAmountPriceDisplay", xmlVersion=FTAP_Display.metadata.languageVersion} );
			FTAP_DisplaySetGet:loadFillTypesIcons();
			FTAP_DisplaySetGet:loadHudIcons(hud);
			FTAP_Display:loadSource(2);	
			hud.onDraw = FTAP_Display_DrawHud.setHud;
			hud.onClick = FTAP_Display_MouseKeyEventsHud.onClick;
			hud.onSaveXml = FTAP_Display_XmlHud.onSaveXml;						
			FTAP_Display_XmlHud:onLoadXml(hud, hud:getXml()); --own hud load over Xml
			if hud.ownTable.viewHudTyp == 1 then hud.autoZoomOutIn = "text";else hud.autoZoomOutIn = "";end; --set text zoom is ...typ 1			
			if g_currentMission.hlHudSystem.isAlreadyExistsXml("box", "FTAP_Display_Box") then FTAP_Display_XmlBox:loadBox("FTAP_Display_Box", true);end; --optional load
		else
			FTAP_Display.loadError = true; --optional for !			
			print("#WARNING: ".. tostring(FTAP_Display.metadata.title).. " CAN NOT GENERATE Hud ! Check/Search: ? Mod cause with integrated HL Hud System ? ")
		end;		
	else
		FTAP_Display.loadError = true; --optional for !		
		g_currentMission.hlUtils.modUnLoad("FS25_FillTypeAmountPriceDisplay");
		print("#WARNING: ".. tostring(FTAP_Display.metadata.title).. " CAN NOT GENERATE Hud/Pda/Box ! MISSING --> HL Hud System ! Check/Search: ? Corrupt Mod with integrated HL Hud System ? ")
	end;	
end;

function FTAP_Display:delete()
	
end;

function FTAP_Display:deleteMap()
			
end;

function FTAP_Display:mouseEvent(posX, posY, isDown, isUp, button)
	
end;	

function FTAP_Display:keyEvent(unicode, sym, modifier, isDown)
	
end;

function FTAP_Display:update(dt)	
	if FTAP_Display:getDetiServer() then return;end;
	if FTAP_Display.lastPlayerFarmId ~= nil and FTAP_Display.lastPlayerFarmId ~= g_currentMission.hlUtils.getPlayerFarmId() then FTAP_Display.lastPlayerFarmId = g_currentMission.hlUtils.getPlayerFarmId();FTAP_DisplaySetGet:resetAllData();end;
end;

function FTAP_Display:draw()
	if FTAP_Display:getDetiServer() or g_currentMission.hlUtils:getIngameMap() or g_currentMission.hlUtils:getFullSize(true,true) then return;end;
	--respect settings for other mods (not every mod) that's why
	setTextAlignment(0);
	setTextLineBounds(0, 0);
	setTextWrapWidth(0);
	setTextColor(1, 1, 1, 1);
	setTextBold(false);
	--respect settings for other mods
			
	if #FTAP_Display.testString > 0 then
		setTextBold(true);		
		for a=1, #FTAP_Display.testString do
			local posY = 0.25-(a/100);
			renderText(0.5, posY, 0.010, "-S ".. tostring(a).. "- ".. tostring(FTAP_Display.testString[a]));
		end;
	end;
	
	--respect settings for other mods
	setTextAlignment(0);
	setTextLineBounds(0, 0);
	setTextWrapWidth(0);
	setTextColor(1, 1, 1, 1);
	setTextBold(false);
	--respect settings for other mods
end;
addModEventListener(FTAP_Display);

function FTAP_Display:getDetiServer()	
	return g_server ~= nil and g_client ~= nil and g_dedicatedServer ~= nil;	
end;

function FTAP_Display:loadSource(int)
	if int == 1 then
		source(FTAP_Display.modDir.."scripte_ftap/FTAP_DisplaySetGet.lua");		
	elseif int == 2 then
		source(FTAP_Display.modDir.."scripte_ftap/mouseKeyEvents/FTAP_Display_MouseKeyEventsHud.lua");
		source(FTAP_Display.modDir.."scripte_ftap/draw/FTAP_Display_DrawHud.lua");
		source(FTAP_Display.modDir.."scripte_ftap/xml/FTAP_Display_XmlHud.lua");
		source(FTAP_Display.modDir.."scripte_ftap/mouseKeyEvents/FTAP_Display_MouseKeyEventsBox.lua");
		source(FTAP_Display.modDir.."scripte_ftap/draw/FTAP_Display_DrawBox.lua");
		source(FTAP_Display.modDir.."scripte_ftap/xml/FTAP_Display_XmlBox.lua");
	end;
end;

function generateFolders()
	createFolder(getUserProfileAppPath().. "modSettings/");
	createFolder(getUserProfileAppPath().. "modSettings/HL/");
	createFolder(getUserProfileAppPath().. "modSettings/HL/FS25_FillTypeAmountPriceDisplay/");
	createFolder(getUserProfileAppPath().. "modSettings/HL/FS25_FillTypeAmountPriceDisplay/languages/");			
end;