FTAP_DisplaySetGet = {};

function FTAP_DisplaySetGet:loadFillTypesIcons()
	g_currentMission.hlUtils.loadFillTypesOverlays();	
end;

function FTAP_DisplaySetGet:loadHudIcons(hud)
	if hud.overlays.modIcons == nil then hud.overlays.modIcons = {byName={}};end;
	local firstIcon, lastIcon = g_currentMission.hlUtils.insertIcons( {xmlTagName="ftap_display.hudIcons", modDir=FTAP_Display.modDir, iconFile="icons_ftap/icons.dds", xmlFile="icons_ftap/icons.xml", modName="FTAP_Display", groupName="hud", fileFormat={64,128,64}, iconTable=hud.overlays.modIcons} );
end;

function FTAP_DisplaySetGet:loadBoxIcons(box)
	if box.overlays.icons == nil then box.overlays.icons = {byName={}};end;
	local firstIcon, lastIcon = g_currentMission.hlUtils.insertIcons( {xmlTagName="ftap_display.boxIcons", modDir=FTAP_Display.modDir, iconFile="hlHudSystem/icons/icons.dds", xmlFile="icons_ftap/icons.xml", modName="defaultIcons", groupName="box", fileFormat={64,512,1024}, iconTable=box.overlays.icons} );
	
	firstIcon, lastIcon = g_currentMission.hlUtils.insertIcons( {xmlTagName="ftap_display.boxOther1Icons", modDir=FTAP_Display.modDir, iconFile="hlHudSystem/icons/other1Icons.dds", xmlFile="icons_ftap/icons.xml", modName="defaultIcons", groupName="box", fileFormat={32,256,512}, iconTable=box.overlays.icons} );
	
	firstIcon, lastIcon = g_currentMission.hlUtils.insertIcons( {xmlTagName="ftap_display.boxOtherIcons", modDir=FTAP_Display.modDir, iconFile="hlHudSystem/icons/otherIcons.dds", xmlFile="icons_ftap/icons.xml", modName="defaultIcons", groupName="box", fileFormat={32,256,512}, iconTable=box.overlays.icons} );

end;

function FTAP_DisplaySetGet:loadFillTypes(box)
	local map = g_currentMission.missionInfo.map;
	local setMarked = box.ownTable.fillTypes.maps[map.id] ~= nil and box.ownTable.fillTypes.maps[map.id].marked ~= nil;
	local defaultNoViewFillTypes = {"UNKNOWN", "AIR", "WEED", "FUEL", "ROUNDBALE_WHEAT", "ROUNDBALE_GRASS", "ROUNDBALE_DRYGRASS", "ROUNDBALE_BARLEY", "SQUAREBALE_WHEAT", "SQUAREBALE_BARLEY", "TARP", "DRYGRASS", "GRASS", "DEF"};
	local noViewFillTypes = {};
	for _, name in pairs(defaultNoViewFillTypes) do
		local fillTypeIndex = g_fillTypeManager:getFillTypeIndexByName(name)
		if fillTypeIndex ~= nil then 
			noViewFillTypes[fillTypeIndex] = name;			
		end;	
	end;
	FTAP_DisplaySetGet.fillTypes = {};
	function regPalFillTypes(desc)
		local palletXmlFile = XMLFile.load("palletXmlFilename", desc.palletFilename, Vehicle.xmlSchema);
		local capacity = FillUnit.getCapacityFromXml(palletXmlFile);
		return {capacity=capacity,xml=Utils.getNoNil(desc.palletFilename, nil)};
	end;
	
	local overlayFillTypesGroup = g_currentMission.hlUtils.overlays["LS_FillTypes"]["fillTypes"];
	local overlayFillTypesByName = g_currentMission.hlUtils.overlays.byName["LS_FillTypes"]["fillTypes"];
	local lineTable = {};
	if g_fillTypeManager.fillTypes ~= nil then		
		for _, desc in pairs(g_fillTypeManager.fillTypes) do		
			if desc ~= nil and desc.name ~= nil and desc.index ~= nil and noViewFillTypes[desc.index] == nil and desc.hudOverlayFilename ~= nil and desc.hudOverlayFilename ~= "" then				
				local overlay = overlayFillTypesGroup[overlayFillTypesByName[desc.name]];
				lineTable[desc.index] = {};
				isLineTable = lineTable[desc.index];
				isLineTable.desc = desc;
				isLineTable.view = true;
				isLineTable.index = desc.index;
				isLineTable.name = desc.name;				
				isLineTable.pricePerLiter= Utils.getNoNil(desc.pricePerLiter, 0);
				isLineTable.isTree = false; --desc.name == "POPLAR"; --simultan Poplar for Trees
				isLineTable.isAnimal = overlay.isAnimal;
				if overlay.isAnimal then 
					isLineTable.subTypeIndex = overlay.subTypeIndex;
					isLineTable.title = overlay.title; --is with subType Name
				elseif isLineTable.isTree then --simultan Poplar for Trees
					isLineTable.title = g_i18n:getText("category_trees"); --.. "/".. g_i18n:getText("infohud_wood");
				else
					isLineTable.title = desc.title;					
				end;
				isLineTable.isCut = not overlay.isAnimal and string.find(desc.name:lower(), "_cut");
				isLineTable.numAnimals = 0;
				isLineTable.animals = {};
				isLineTable.bales = {};
				isLineTable.pallets = {};
				isLineTable.trees = {};
				isLineTable.totalAmount = Utils.getNoNil(desc.totalAmount, 0);
				isLineTable.bestPrice = 0;
				isLineTable.sortByNumber = 0;
				isLineTable.sortByString = "";
				isLineTable.sortByBoolean = false;
				isLineTable.priceTrend = "normal";
				isLineTable.amounts = {};
				isLineTable.bestPrices = {};
				isLineTable.monthPrices = FTAP_DisplaySetGet:getMonthPrices(desc);				
				isLineTable.greatDemand = {};
				isLineTable.canPal = desc.palletFilename ~= nil;
				if isLineTable.canPal then isLineTable.pal = regPalFillTypes(desc);end;
				isLineTable.viewAmountStorages = false;
				isLineTable.viewBestPriceStations = false;
				if setMarked and box.ownTable.fillTypes.maps[map.id].marked[desc.name] ~= nil then isLineTable.isMarked = true;else isLineTable.isMarked = false;end;
				isLineTable.showOnPriceTable = Utils.getNoNil(desc.showOnPriceTable, true);
				isLineTable.desiredSellPrice = 0;
				isLineTable.isBaleType = desc.isBaleType or false;
				isLineTable.isPalletType = desc.isPalletType or false;
				isLineTable.isBulkType = desc.isBulkType or false;
			end;
		end;
		FTAP_DisplaySetGet.fillTypes = lineTable;
		--FTAP_DisplaySetGet:setFillTypesPrice(); --first start
		--FTAP_DisplaySetGet:setFillTypesAmount(); --first start
		--FTAP_DisplaySetGet:setNumOfAnimals(); --first start test
		--FTAP_DisplaySetGet:setPalletsAmount(); --first start test
		--FTAP_DisplaySetGet:setBalesAmount(); --first start test		
		--print(DebugUtil.printTableRecursively(FTAP_DisplaySetGet.fillTypes, "fillTypes ", 0, 5))		
	end;
end;

function FTAP_DisplaySetGet:setViewFillTypes(box)	
	local viewFillTypes = {};
	local values = box.ownTable;
	if (values.viewPrice or values.viewPriceTrend) and g_currentMission.hlUtils.timers["ftap_updatePrice"] == nil then g_currentMission.hlUtils.addTimer( {delay=values.priceUpdateTimer or 5, name="ftap_updatePrice", repeatable=1, ms=false, action=FTAP_DisplaySetGet.setFillTypesPriceUpdateByTimer} );end;
	if (values.viewFillAmounts or values.viewEmptyAmounts) and g_currentMission.hlUtils.timers["ftap_updateAmount"] == nil then g_currentMission.hlUtils.addTimer( {delay=values.amountUpdateTimer or 1, name="ftap_updateAmount", repeatable=1, ms=false, action=FTAP_DisplaySetGet.setFillTypesAmountUpdateByTimer} );end;
	if (values.viewAnimals) and g_currentMission.hlUtils.timers["ftap_updateAnimals"] == nil then g_currentMission.hlUtils.addTimer( {delay=values.animalsUpdateTimer or 200, name="ftap_updateAnimals", repeatable=1, ms=false, action=FTAP_DisplaySetGet.setNumOfAnimalsUpdateByTimer} );end;
	if (values.viewPal) and g_currentMission.hlUtils.timers["ftap_updatePallets"] == nil then g_currentMission.hlUtils.addTimer( {delay=values.palletsUpdateTimer or 100, name="ftap_updatePallets", repeatable=1, ms=false, action=FTAP_DisplaySetGet.setPalletsUpdateByTimer} );end;
	if (values.viewBales) and g_currentMission.hlUtils.timers["ftap_updateBales"] == nil then g_currentMission.hlUtils.addTimer( {delay=values.balesUpdateTimer or 100, name="ftap_updateBales", repeatable=1, ms=false, action=FTAP_DisplaySetGet.setBalesUpdateByTimer} );end;	
	
	local animals = {};	
	local pallets = {};
	local bales = {};	
	local openGroup = false;
	
	function setSortBy()
		if values.sortBy > 1 and #viewFillTypes > 0 then
			for a=1, #viewFillTypes do
				if values.sortBy == 2 then --by Name
					viewFillTypes[a].sortByString = viewFillTypes[a].title;					
				elseif values.sortBy == 3 then --by Amount
					local storageAmount = viewFillTypes[a].amounts.fillLevel ~= nil;
					local balesAmount = values.viewBales and viewFillTypes[a].bales.fillLevel ~= nil;
					local palletsAmount = values.viewPal and viewFillTypes[a].pallets.fillLevel ~= nil;					
					if storageAmount or balesAmount or palletsAmount then
						viewFillTypes[a].sortByNumber = Utils.getNoNil(viewFillTypes[a].amounts.fillLevel, 0);
						if balesAmount then viewFillTypes[a].sortByNumber = viewFillTypes[a].sortByNumber + Utils.getNoNil(viewFillTypes[a].bales.fillLevel, 0);end;
						if palletsAmount then viewFillTypes[a].sortByNumber = viewFillTypes[a].sortByNumber + Utils.getNoNil(viewFillTypes[a].pallets.fillLevel, 0);end;						
					else
						viewFillTypes[a].sortByNumber = 0;
					end;
				elseif values.sortBy == 4 then --by Price					
					viewFillTypes[a].sortByNumber = Utils.getNoNil(viewFillTypes[a].bestPrice, 0);	
				elseif values.sortBy == 5 then --by Season current Period
					local canViewMonthPrice = viewFillTypes[a].monthPrices ~= nil and viewFillTypes[a].monthPrices[1] ~= nil and viewFillTypes[a].monthPrices[1].hasFluctuations;
					local isCurrentPeriod = canViewMonthPrice and ((g_currentMission.environment.currentPeriod == viewFillTypes[a].monthPrices[1].month) or (viewFillTypes[a].monthPrices[1].doubleBestMonth and g_currentMission.environment.currentPeriod == viewFillTypes[a].monthPrices[2].month));
					viewFillTypes[a].sortByBoolean = isCurrentPeriod;					
				elseif values.sortBy == 6 then --by bestPrice ready
					local canViewMonthPrice = viewFillTypes[a].monthPrices ~= nil and viewFillTypes[a].monthPrices[1] ~= nil and viewFillTypes[a].monthPrices[1].hasFluctuations;
					local bestPriceReady = (canViewMonthPrice and viewFillTypes[a].bestPrices[1] ~= nil and viewFillTypes[a].bestPrices[1].price >= viewFillTypes[a].monthPrices[1].price) or (canViewMonthPrice and viewFillTypes[a].monthPrices[1].doubleBestMonth and viewFillTypes[a].bestPrices[1] ~= nil and viewFillTypes[a].bestPrices[1].price >= viewFillTypes[a].monthPrices[2].price);
					viewFillTypes[a].sortByBoolean = bestPriceReady;
				end;
			end;
			function sortByString(w1,w2)			
				if w1.sortByString < w2.sortByString then
					return true;
				end;			
			end;
			function sortByNumber(w1,w2)		
				if w1.sortByNumber > w2.sortByNumber then
					return true;
				end;				
			end;
			function sortByBoolean(w1,w2)		
				return w1.sortByBoolean and not w2.sortByBoolean;							
			end;
			if values.sortBy == 2 then table.sort(viewFillTypes, sortByString);end;
			if values.sortBy == 3 or values.sortBy == 4 then table.sort(viewFillTypes, sortByNumber);end;
			if values.sortBy == 5 or values.sortBy == 6 then table.sort(viewFillTypes, sortByBoolean);end;
		end;
		--set marked onTop with sortBy--
		if #viewFillTypes > 0 then
			local tempViewFillTypes = {};
			local lastMarkedPos = 0;
			for a=1, #viewFillTypes do
				if viewFillTypes[a].isMarked then
					table.insert(tempViewFillTypes, lastMarkedPos+1, viewFillTypes[a]);
					lastMarkedPos = lastMarkedPos+1;
				else
					table.insert(tempViewFillTypes, viewFillTypes[a]);
				end;
			end;
			viewFillTypes = tempViewFillTypes
		end;
		--setMarked onTop with sortBy--
	end;
	
	if box.searchFilter:len() > 0 then		
		local updateAmounts = false;
		local searchText = box.searchFilter;
		local isDemand = string.find(box.searchFilter:lower(), "demand");
		local isBales = string.find(box.searchFilter:lower(), "bale");
		if isBales and not values.viewBales then box.ownTable.viewBales = true;FTAP_DisplaySetGet:setBalesAmount();updateAmounts=true;end;
		local isPallets = string.find(box.searchFilter:lower(), "pallet");
		if isPallets and not values.viewPal then box.ownTable.viewPal = true;FTAP_DisplaySetGet:setPalletsAmount();updateAmounts=true;end;		
		if isPallets and not values.viewProductions then box.ownTable.viewProductions = true;updateAmounts=true;end;	
		if updateAmounts then FTAP_DisplaySetGet:setFillTypesAmount();end;
		local isNotFirstCharacter = string.find(box.searchFilter, "*");
		if isNotFirstCharacter then searchText = string.gsub(box.searchFilter, "*", "");end;
		for k,v in pairs (FTAP_DisplaySetGet.fillTypes) do
			if not openGroup and (v.viewAmountStorages or v.viewBestPriceStations) then openGroup = true;end;
			if isDemand or isBales or isPallets then --multiple
				local setFillType = false;
				if isDemand and not setFillType then
					if v.priceTrend == "GreatDemand" or v.greatDemand[1] ~= nil then
						if v.isAnimal then animals[#animals+1] = v;else viewFillTypes[#viewFillTypes+1] = v;end;
						setFillType = true;
					end;
				end;
				if isBales and not setFillType then				
					local isBalesObject = v.amounts ~= nil and v.amounts.objectBales ~= nil and v.amounts.objectBales;
					if isBalesObject or (v.bales ~= nil and v.bales.fillLevel ~= nil and v.bales.fillLevel > 0) then
						if v.isAnimal then animals[#animals+1] = v;else viewFillTypes[#viewFillTypes+1] = v;end;
						setFillType = true;
					end;
				end;
				if isPallets and not setFillType then				
					local isPalletsObject = v.amounts ~= nil and v.amounts.objectPallets ~= nil and v.amounts.objectPallets;
					if isPalletsObject or (v.pallets ~= nil and v.pallets.fillLevel ~= nil and v.pallets.fillLevel > 0) then
						if v.isAnimal then animals[#animals+1] = v;else viewFillTypes[#viewFillTypes+1] = v;end;
						setFillType = true;
					end;
				end;
			elseif isNotFirstCharacter then
				if string.find(v.title:lower(), searchText:lower()) then
					if v.isAnimal then animals[#animals+1] = v;else viewFillTypes[#viewFillTypes+1] = v;end;
				end;
			else
				local tempTitle = string.sub(v.title, 0, box.searchFilter:len())
				if string.find(tempTitle:lower(), searchText:lower()) then
					if v.isAnimal then animals[#animals+1] = v;else viewFillTypes[#viewFillTypes+1] = v;end;
				end;
			end;
		end;
		setSortBy();
	else
		for k,v in pairs (FTAP_DisplaySetGet.fillTypes) do			
			if not openGroup and (v.viewAmountStorages or v.viewBestPriceStations) then openGroup = true;end;
			local canViewPallets = values.viewPal and v.pallets.fillLevel ~= nil;
			local canViewBales = values.viewBales and v.bales.fillLevel ~= nil;			
			local isMarked = v.isMarked;
			local isViewShowOnPriceTable = (v.showOnPriceTable and values.viewShowOnPriceTable) or (not values.viewShowOnPriceTable);			
			if (isViewShowOnPriceTable and values.viewFillAmounts and values.viewEmptyAmounts) or isMarked then
				if v.isAnimal and not isMarked then animals[#animals+1] = v;else viewFillTypes[#viewFillTypes+1] = v;end;		
			elseif isViewShowOnPriceTable and values.viewFillAmounts and ( (v.amounts.fillLevel ~= nil and v.amounts.fillLevel > 0) or (canViewPallets and v.pallets.fillLevel > 0) or (canViewBales and v.bales.fillLevel > 0) ) then
				if v.isAnimal then animals[#animals+1] = v;else viewFillTypes[#viewFillTypes+1] = v;end;
			elseif isViewShowOnPriceTable and values.viewEmptyAmounts and (v.amounts.fillLevel ~= nil and v.amounts.fillLevel == 0 and (not values.viewPal or (canViewPallets and v.pallets.fillLevl == 0) ) and (not values.viewBales or (canViewBales and v.bales.fillLevel == 0) ) ) then
				if v.isAnimal then animals[#animals+1] = v;else viewFillTypes[#viewFillTypes+1] = v;end;	
			elseif values.viewAnimals and v.isAnimal then
				if values.viewFillAmounts and v.numAnimals ~= nil and v.numAnimals > 0 then
					animals[#animals+1] = v;
				elseif values.viewEmptyAmounts and v.numAnimals ~= nil and v.numAnimals == 0 then
					animals[#animals+1] = v;
				end;			
			end;			
		end;		
		setSortBy();
	end;	
	if values.viewAnimals and #animals > 0 then
		table.foreach(animals, function(k, v) table.insert(viewFillTypes, v) end);		
	end;	
	FTAP_DisplaySetGet.viewFillTypes = viewFillTypes;
	return openGroup;
end;

function FTAP_DisplaySetGet:setDesiredSellPrice(box, fillTypeIndex)
	local map = g_currentMission.missionInfo.map;	
	local text = FTAP_DisplaySetGet.fillTypes[fillTypeIndex].title.. " ".. g_i18n:getText("button_apply"); 
	local confirmText = g_i18n:getText("ui_sellPrices").. "/".. g_i18n:getText("button_apply");
	local backText = g_i18n:getText("button_close").. "/".. g_i18n:getText("button_delete")
	g_gui:showTextInputDialog({
		text = text,
		defaultText = tostring(FTAP_DisplaySetGet.fillTypes[fillTypeIndex].desiredSellPrice),
		callback = function (result, yes)
			if yes then
				if tonumber(result) == nil or tonumber(result) < 1 then
					if box.ownTable.fillTypes.maps[map.id] ~= nil and box.ownTable.fillTypes.maps[map.id].desiredSellPrice ~= nil and box.ownTable.fillTypes.maps[map.id].desiredSellPrice[FTAP_DisplaySetGet.fillTypes[fillTypeIndex].name] ~= nil then box.ownTable.fillTypes.maps[map.id].desiredSellPrice[FTAP_DisplaySetGet.fillTypes[fillTypeIndex].name] = nil;end;
					FTAP_DisplaySetGet.fillTypes[fillTypeIndex].desiredSellPrice = 0;					
				else
					if box.ownTable.fillTypes.maps[map.id] == nil then box.ownTable.fillTypes.maps[map.id] = {marked={}, desiredSellPrice={}};end;
					box.ownTable.fillTypes.maps[map.id].desiredSellPrice[FTAP_DisplaySetGet.fillTypes[fillTypeIndex].name] = tonumber(result);
					FTAP_DisplaySetGet.fillTypes[fillTypeIndex].desiredSellPrice = tonumber(result);					
				end;				
			else
				if box.ownTable.fillTypes.maps[map.id] ~= nil and box.ownTable.fillTypes.maps[map.id].desiredSellPrice ~= nil and box.ownTable.fillTypes.maps[map.id].desiredSellPrice[FTAP_DisplaySetGet.fillTypes[fillTypeIndex].name] ~= nil then box.ownTable.fillTypes.maps[map.id].desiredSellPrice[FTAP_DisplaySetGet.fillTypes[fillTypeIndex].name] = nil;end;
				FTAP_DisplaySetGet.fillTypes[fillTypeIndex].desiredSellPrice = 0;
			end;
			--box:setUpdateState();
		end,
		dialogPrompt = g_i18n:getText("ui_buyPrices").. "/INFO",
		imePrompt = g_i18n:getText("ui_prices"),
		confirmText = confirmText,
		backText = backText;
		maxCharacters = 6,
		disableFilter = true		
	})
end;

function FTAP_DisplaySetGet:setClosedAllGroups()
	for k,v in pairs (FTAP_DisplaySetGet.fillTypes) do
		if v.viewAmountStorages ~= nil then v.viewAmountStorages = false;end;
		if v.viewBestPriceStations ~= nil then v.viewBestPriceStations = false;end;
	end;
end;

function FTAP_DisplaySetGet.setFillTypesPriceUpdateByTimer()
	if g_currentMission.missionDynamicInfo.isMultiplayer and g_currentMission.hlHudSystem.ownData ~= nil and g_currentMission.hlHudSystem.ownData.mpOff then return;end;
	if g_currentMission.hlHudSystem.ownData.hiddenMods["FillTypeAmountPriceDisplay"].isHidden then return;end;
	FTAP_DisplaySetGet:setFillTypesPrice();
end;

function FTAP_DisplaySetGet.setFillTypesAmountUpdateByTimer()
	if g_currentMission.missionDynamicInfo.isMultiplayer and g_currentMission.hlHudSystem.ownData ~= nil and g_currentMission.hlHudSystem.ownData.mpOff then return;end;
	if g_currentMission.hlHudSystem.ownData.hiddenMods["FillTypeAmountPriceDisplay"].isHidden then return;end;
	FTAP_DisplaySetGet:setFillTypesAmount();
end;

function FTAP_DisplaySetGet.setNumOfAnimalsUpdateByTimer()
	if g_currentMission.missionDynamicInfo.isMultiplayer and g_currentMission.hlHudSystem.ownData ~= nil and g_currentMission.hlHudSystem.ownData.mpOff then return;end;
	if g_currentMission.hlHudSystem.ownData.hiddenMods["FillTypeAmountPriceDisplay"].isHidden then return;end;
	FTAP_DisplaySetGet:setNumOfAnimals();
end;

function FTAP_DisplaySetGet.setPalletsUpdateByTimer()
	if g_currentMission.missionDynamicInfo.isMultiplayer and g_currentMission.hlHudSystem.ownData ~= nil and g_currentMission.hlHudSystem.ownData.mpOff then return;end;
	if g_currentMission.hlHudSystem.ownData.hiddenMods["FillTypeAmountPriceDisplay"].isHidden then return;end;
	FTAP_DisplaySetGet:setPalletsAmount();
end;

function FTAP_DisplaySetGet.setBalesUpdateByTimer()
	if g_currentMission.missionDynamicInfo.isMultiplayer and g_currentMission.hlHudSystem.ownData ~= nil and g_currentMission.hlHudSystem.ownData.mpOff then return;end;
	if g_currentMission.hlHudSystem.ownData.hiddenMods["FillTypeAmountPriceDisplay"].isHidden then return;end;
	FTAP_DisplaySetGet:setBalesAmount();
end;

function FTAP_DisplaySetGet:getNameMissingXmlText(text, name)
	if text == nil or text:len() == 0 then return string.format(g_i18n:getText("missing_txt"), name or "Object");end;
	if string.find(text:lower(), "missing") or string.find(text:lower(), ".xml") then return string.format(g_i18n:getText("missing_txt"), name or "Object");end;
	return text;
end;

function FTAP_DisplaySetGet:getMonthPrices(fillType)	
	local difficultyMultiplier = 1000;	
	local month = {};
	local minPrice = 0;
	local maxPrice = 0;	
	for p=1, Environment.PERIODS_IN_YEAR do 
		local price = math.floor((fillType.pricePerLiter or 0.0) * (fillType.economy.factors[p] or 1.0) * difficultyMultiplier * EconomyManager.getPriceMultiplier(), -0.5);
		if price > maxPrice or maxPrice == 0 then maxPrice = price;end;
		if price < minPrice or minPrice == 0 then minPrice = price;end;
		month[#month+1] = {price=price,month=p,formatMonth=g_i18n:formatPeriod(p,true),doubleBestMonth=false,hasFluctuations=false};
	end;
	local hasFluctuations = minPrice ~= maxPrice;
	function setFluctuations()
		for m=1, #month do
			month[m].hasFluctuations = hasFluctuations;
		end;
	end;
	if hasFluctuations then setFluctuations();end; 
	function comp(w1,w2)			
		if not hasFluctuations then return false;end;
		if w1.price > w2.price then
			return true;
		end;			
	end;
	if hasFluctuations then table.sort(month, comp);end;
	if hasFluctuations and month[1].price == month[2].price then
		month[1].doubleBestMonth = true;
		month[2].doubleBestMonth = true;
		if month[1].month > month[2].month then
			table.insert(month, 1, month[2]);
			table.remove(month, 3);
		end;
	end;
	return month;	
end;

function FTAP_DisplaySetGet:searchBug(change) --bug not view prices !
	if change == 1 then
		print("##########FTAP Mod-Change 1 bug search begin")
		local sellingStations = FTAP_DisplaySetGet:getSellingStations();
		if sellingStations ~= nil and #sellingStations > 0 then
			for s=1, #sellingStations do
				local sellingStation = sellingStations[s];
				print(DebugUtil.printTableRecursively(sellingStation, "sellingStation ", 0, 1))
				break;
			end;
		end;
		print("##########FTAP Mod-Change 1 bug search end")
	elseif change == 2 then
		print("##########FTAP Mod-Change 2 bug search begin")
		local sellingStations = FTAP_DisplaySetGet:getSellingStations();
		if sellingStations ~= nil and #sellingStations > 0 then
			for s=1, #sellingStations do
				local sellingStation = sellingStations[s];
				print("#ownerFarmId: ".. tostring(sellingStation.ownerFarmId))
				local stationName = FTAP_DisplaySetGet:getNameMissingXmlText(Utils.getNoNil(sellingStation.uiName, sellingStation.stationName), "Stations");
				print("#StationName: ".. tostring(stationName))
				print("###accepted FillTypes begin")
				for index,isAccepted in pairs(sellingStation:getSupportedFillTypes()) do
					if isAccepted then
						local difficultyMultiplier = 1000;
						local price = math.floor(sellingStation:getEffectiveFillTypePrice(index) * difficultyMultiplier - 0.5);
						print("#FillTypes: name=".. tostring(FTAP_DisplaySetGet.fillTypes[index].title).. "/index=".. tostring(index).. "/price:".. tostring(price))
					end;
				end;
				print("###accepted FillTypes end")
				print(DebugUtil.printTableRecursively(sellingStation, "sellingStation ", 0, 1))
				break;
			end;
		end;		
		print("##########FTAP Mod-Change 2 bug search end")
	end;
end;

function FTAP_DisplaySetGet:getSellingStations(sort)
	local sellingStations = {};
	for _, station in pairs(g_currentMission.storageSystem:getUnloadingStations()) do
		if station:isa(SellingStation) and not station.hideFromPricesMenu then --bug not view prices !
		--if station.isSellingPoint and (station.hideFromPricesMenu == nil or not station.hideFromPricesMenu) then
			station.uiName = station:getName();			
			table.insert(sellingStations, station);			
		end;
	end;
	if sort ~= nil and sort then
		function comp(w1,w2)			
			if w1.uiName < w2.uiName then
				return true;
			end;			
		end;
		table.sort(sellingStations, comp);
	end;
	return sellingStations;
end;

function FTAP_DisplaySetGet:searchMapHotspot(object)
	if object ~= nil then
		
	end;
end;

function FTAP_DisplaySetGet:getPrices(sort)
	local sellingStations = FTAP_DisplaySetGet:getSellingStations();
	local prices = {};
	if sellingStations ~= nil and #sellingStations > 0 then
		for s=1, #sellingStations do
			local sellingStation = sellingStations[s];
			if sellingStation.ownerFarmId == 0 then --keine eigenen produktionen anzeigen	
				local objectId = Utils.getNoNil(sellingStation.rootNode, sellingStation.nodeId);					
				local stationName = FTAP_DisplaySetGet:getNameMissingXmlText(Utils.getNoNil(sellingStation.uiName, sellingStation.stationName), "Stations");
				local mapHotspot = nil;
				if sellingStation.owningPlaceable ~= nil and sellingStation.owningPlaceable.spec_hotspots ~= nil then mapHotspot = sellingStation.owningPlaceable.spec_hotspots;end;
				for index,isAccepted in pairs(sellingStation:getSupportedFillTypes()) do
					if isAccepted then
						local difficultyMultiplier = 1000;
						if prices[index] == nil then prices[index] = {};end;								
						local price = math.floor(sellingStation:getEffectiveFillTypePrice(index) * difficultyMultiplier - 0.5);
						local priceTrend = sellingStation:getCurrentPricingTrend(index)
						local isPriceTrend = "Normal";
						if priceTrend ~= nil then
							if Utils.isBitSet(priceTrend, SellingStation.PRICE_GREAT_DEMAND) then
								isPriceTrend = "GreatDemand";								
							elseif Utils.isBitSet(priceTrend, SellingStation.PRICE_CLIMBING) then
								isPriceTrend = "Up";
							elseif Utils.isBitSet(priceTrend, SellingStation.PRICE_FALLING) then
								isPriceTrend = "Down";
							end;
						end;					
						prices[index][#prices[index]+1] = {price=price, stationName=stationName, priceTrend=isPriceTrend, index=index, nodeId=objectId, mapHotspot=mapHotspot};
					end;
				end;
			end;
		end;
	end;
	if sort ~= nil and sort then
		function comp(w1,w2)		
			if w1.price > w2.price then
				return true;
			end;				
		end;		
		for index, _ in pairs(prices) do
			table.sort(prices[index], comp);
		end;
	end;
	return prices;
end;

function FTAP_DisplaySetGet:getAmounts(sort) --storages,productions,storageObjecte,beehives
	local playerFarmId = g_currentMission.hlUtils.getPlayerFarmId();
	local amounts = {};
	local box = g_currentMission.hlHudSystem.hlBox:getData("FTAP_Display_Box");	
	local viewProductions = box ~= nil and box.ownTable ~= nil and box.ownTable.viewProductions;
		
	for _, storage in pairs(g_currentMission.storageSystem:getStorages()) do
		if storage:getOwnerFarmId() == playerFarmId and storage.loadingStations ~= nil then --and storage.foreignSilo ~= farmSilo then	--train other		
			local fillLevels = storage:getFillLevels();			
			local capacity = storage.capacity;
			if fillLevels ~= nil then
				for index, fillLevel in pairs(fillLevels) do					
					for _, loadingStation in pairs (storage.loadingStations) do
						if loadingStation ~= nil then							
							if loadingStation:getIsFillTypeSupported(index) then
								if amounts[index] == nil then amounts[index] = {fillLevel=0,storage={},capacity=0, objectBales=false, objectPallets=false};end;
								amounts[index].fillLevel = Utils.getNoNil(amounts[index].fillLevel, 0) + Utils.getNoNil(fillLevel, 0);						
								amounts[index].capacity = Utils.getNoNil(amounts[index].capacity, 0) + Utils.getNoNil(storage.capacity, 0);								
								local objectId = loadingStation.rootNode or loadingStation.nodeId;
								if objectId ~= nil then
									local mapHotspot = nil;
									if loadingStation.owningPlaceable ~= nil then mapHotspot = loadingStation.owningPlaceable.spec_hotspots;end;
									if amounts[index].storage[objectId] == nil then amounts[index].storage[objectId] = {fillLevel=0,capacity=0,mapHotspot=mapHotspot,objectName=FTAP_DisplaySetGet:getNameMissingXmlText(Utils.getNoNil(loadingStation:getName(), nil), "Storage"), production=false, beehive=false, nodeId=objectId};end;
									amounts[index].storage[objectId].fillLevel = Utils.getNoNil(amounts[index].storage[objectId].fillLevel, 0) + Utils.getNoNil(fillLevel, 0);
									local tempCapacity = 0;
									if storage.capacities ~= nil then tempCapacity = Utils.getNoNil(storage.capacities[index], 0);end;
									amounts[index].storage[objectId].capacity = Utils.getNoNil(amounts[index].storage[objectId].capacity, 0) + tempCapacity;
								end;								
							end;							
						end;
					end;									
				end;				
			end;			
		end;		
	end;	
	
	if g_currentMission.beehiveSystem ~= nil then		
		local beehivePalSpawner = g_currentMission.beehiveSystem:getFarmBeehivePalletSpawner(playerFarmId);
		if beehivePalSpawner ~= nil and beehivePalSpawner.spec_beehivePalletSpawner ~= nil then
			local fillType = beehivePalSpawner.spec_beehivePalletSpawner.fillType;
			local fillLevel = beehivePalSpawner.spec_beehivePalletSpawner.pendingLiters; 
			if fillType ~= nil then
				if amounts[fillType] == nil then amounts[fillType] = {fillLevel=0,storage={},capacity=0, objectBales=false, objectPallets=false};end;
				amounts[fillType].fillLevel = Utils.getNoNil(amounts[fillType].fillLevel, 0) + Utils.getNoNil(fillLevel, 0);
				if amounts[fillType].fillLevel > 0 then amounts[fillType].objectPallets = true;end;
				local objectId = beehivePalSpawner.rootNode or beehivePalSpawner.nodeId;
				if objectId ~= nil then
					local mapHotspot = beehivePalSpawner.spec_hotspots;
					if amounts[fillType].storage[objectId] == nil then amounts[fillType].storage[objectId] = {fillLevel=0,capacity=0,mapHotspot=mapHotspot,objectName=FTAP_DisplaySetGet:getNameMissingXmlText(Utils.getNoNil(beehivePalSpawner:getName(), nil), "BehivePalSpawner"), production=false, beehive=true, pallets=0, nodeId=objectId};end;
					amounts[fillType].storage[objectId].fillLevel = Utils.getNoNil(amounts[fillType].storage[objectId].fillLevel, 0) + Utils.getNoNil(fillLevel, 0);
					if amounts[fillType].storage[objectId].fillLevel > 0 then
						if FTAP_DisplaySetGet.fillTypes[fillType] ~= nil and FTAP_DisplaySetGet.fillTypes[fillType].canPal and FTAP_DisplaySetGet.fillTypes[fillType].pal ~= nil then
							amounts[fillType].storage[objectId].pallets = math.floor(amounts[fillType].storage[objectId].fillLevel/FTAP_DisplaySetGet.fillTypes[fillType].pal.capacity, -0.5)
						end;
					end;
				end;			
			end;			
		end;		
	end;
			
	if viewProductions then	
		if g_currentMission.productionChainManager ~= nil and g_currentMission.productionChainManager.farmIds ~= nil then
			if g_currentMission.productionChainManager.farmIds[playerFarmId] ~= nil and g_currentMission.productionChainManager.farmIds[playerFarmId].productionPoints ~= nil then
				for _, productionPoint in pairs(g_currentMission.productionChainManager.farmIds[playerFarmId].productionPoints) do
					if productionPoint.productions ~= nil and #productionPoint.productions > 0 then
						local objectId = nil;
						if productionPoint.loadingStation ~= nil then objectId = productionPoint.loadingStation.rootNode or productionPoint.loadingStation.nodeId;end;
						if objectId == nil and productionPoint.node ~= nil then objectId = productionPoint.node;end;
						local outputFillTypeDouble = {};
						for p=1, #productionPoint.productions do
							local production = productionPoint.productions[p]
							if production ~= nil then							
								for o=1, #production.outputs do
									local output = production.outputs[o];									
									if outputFillTypeDouble[output.type] == nil then
										outputFillTypeDouble[output.type] = true;
										local directSell = productionPoint.outputFillTypeIdsDirectSell[output.type] ~= nil and productionPoint.outputFillTypeIdsDirectSell[output.type] == true;
										local directDeliver = productionPoint.outputFillTypeIdsAutoDeliver[output.type] ~= nil and productionPoint.outputFillTypeIdsAutoDeliver[output.type] == true;
										if objectId ~= nil and not directSell then --and not directDeliver then
											local mapHotspot = nil;
											if productionPoint.owningPlaceable ~= nil then mapHotspot = productionPoint.owningPlaceable.spec_hotspots;end;
											local fillLevel = productionPoint.storage:getFillLevel(output.type);
											local capacity = productionPoint.storage:getCapacity(output.type);
											local isPal = productionPoint.outputFillTypeIdsToPallets ~= nil and productionPoint.outputFillTypeIdsToPallets[output.type] ~= nil;
											if amounts[output.type] == nil then amounts[output.type] = {fillLevel=0,storage={},capacity=0, objectBales=false, objectPallets=false};end;
											amounts[output.type].fillLevel = Utils.getNoNil(amounts[output.type].fillLevel, 0) + Utils.getNoNil(fillLevel, 0);
											if isPal and amounts[output.type].fillLevel > 0 then
												amounts[output.type].objectPallets = true;
											end;
											if amounts[output.type].storage[objectId] == nil then
												amounts[output.type].storage[objectId] = {fillLevel=0,capacity=0,mapHotspot=mapHotspot,objectName=FTAP_DisplaySetGet:getNameMissingXmlText(Utils.getNoNil(productionPoint:getName(), nil), "Productions"),production=true, beehive=false, nodeId=objectId, directDeliver=directDeliver};
											end;
											amounts[output.type].storage[objectId].fillLevel = amounts[output.type].storage[objectId].fillLevel + Utils.getNoNil(fillLevel, 0);											
											amounts[output.type].storage[objectId].capacity = amounts[output.type].storage[objectId].capacity + Utils.getNoNil(capacity, 0);									
										end;
									end;
								end;
							end;
						end;
					end;
				end;
			end;
		end;
	end;
		
	if g_currentMission.placeableSystem ~= nil and g_currentMission.placeableSystem.placeables ~= nil and #g_currentMission.placeableSystem.placeables > 0 then
		for po=1,#g_currentMission.placeableSystem.placeables do 
			local object = g_currentMission.placeableSystem.placeables[po];			
			if object ~= nil and object.ownerFarmId == playerFarmId then
				local objectId = object.rootNode or object.nodeId or object.node;
				local mapHotspot = object.spec_hotspots;
				local objectName = FTAP_DisplaySetGet:getNameMissingXmlText(object:getName(), "Object");				
				---------
				function setObjectBunker(bunkerObject)
					if bunkerObject ~= nil then
						local fillType = bunkerObject.inputFillType;
						local fillLevel = bunkerObject.fillLevel or 0;
						local state = bunkerObject.state;
						local percentF = bunkerObject.fermentingPercent;
						if state == BunkerSilo.STATE_CLOSED or state == BunkerSilo.STATE_FERMENTED or state == BunkerSilo.STATE_DRAIN then
							fillType = bunkerObject.outputFillType;
						end;
						if fillType ~= nil then
							if amounts[fillType] == nil then amounts[fillType] = {fillLevel=0,storage={},capacity=0, objectBales=false, objectPallets=false};end;
							amounts[fillType].fillLevel = Utils.getNoNil(amounts[fillType].fillLevel, 0) + Utils.getNoNil(fillLevel, 0);
							if amounts[fillType].storage[objectId] == nil then
								amounts[fillType].storage[objectId] = {fillLevel=0,capacity=0,mapHotspot=mapHotspot,objectName=objectName,production=false,beehive=false,nodeId=objectId,percentF=0,state=state};
							end;
							amounts[fillType].storage[objectId].fillLevel = amounts[fillType].storage[objectId].fillLevel + Utils.getNoNil(fillLevel, 0);
							amounts[fillType].storage[objectId].percentF = amounts[fillType].storage[objectId].percentF + Utils.getNoNil(percentF, 0);
						end;
					end;
				end;
				function setObjectStorage(storageObject, numObjects, areas)
					if storageObject ~= nil then
						local fillType = nil;
						local fillLevel = nil;
						local isFermenting = nil;
						if storageObject.baleAttributes ~= nil then	
							fillType = storageObject.baleAttributes.fillType;
							fillLevel = storageObject.baleAttributes.fillLevel*(numObjects or 1);
							isFermenting = storageObject.baleAttributes.isFermenting; ---!
						elseif storageObject.baleObject ~= nil then
							fillType = storageObject.baleObject.fillType;
							fillLevel = storageObject.baleObject.fillLevel*(numObjects or 1);
							isFermenting = storageObject.baleObject.isFermenting; ---!
						elseif storageObject.palletAttributes ~= nil then	
							fillType = storageObject.palletAttributes.fillType;
							fillLevel = storageObject.palletAttributes.fillLevel*(numObjects or 1);
						elseif storageObject.palletObject ~= nil then	
							fillType = storageObject.palletObject.fillType;
							fillLevel = storageObject.palletObject.fillLevel*(numObjects or 1);
						elseif areas ~= nil and areas then
							
						end;
						if fillType ~= nil then	
							if amounts[fillType] == nil then amounts[fillType] = {fillLevel=0,storage={},capacity=0, objectBales=false, objectPallets=false};end;
							amounts[fillType].fillLevel = Utils.getNoNil(amounts[fillType].fillLevel, 0) + Utils.getNoNil(fillLevel, 0);
							if amounts[fillType].fillLevel > 0 then 
								if storageObject.baleAttributes ~= nil or storageObject.baleObject ~= nil then amounts[fillType].objectBales = true;end;
								if storageObject.palletAttributes ~= nil or storageObject.palletObject ~= nil then amounts[fillType].objectPallets = true;end;
							end;
							if amounts[fillType].storage[objectId] == nil then
								amounts[fillType].storage[objectId] = {fillLevel=0,capacity=0,mapHotspot=mapHotspot,objectName=objectName,production=false,beehive=false,nodeId=objectId,bales=0,pallets=0};
							end;
							if storageObject.baleAttributes ~= nil or storageObject.baleObject ~= nil then 
								if numObjects ~= nil and numObjects ~= 1 then
									amounts[fillType].storage[objectId].bales = amounts[fillType].storage[objectId].bales + numObjects;
								else
									amounts[fillType].storage[objectId].bales = amounts[fillType].storage[objectId].bales + 1;
								end;
							end;
							if storageObject.palletAttributes ~= nil or storageObject.palletObject ~= nil then 
								if numObjects ~= nil and numObjects ~= 1 then
									amounts[fillType].storage[objectId].pallets = amounts[fillType].storage[objectId].pallets + numObjects;
								else
									amounts[fillType].storage[objectId].pallets = amounts[fillType].storage[objectId].pallets + 1;
								end;
							end;							
							amounts[fillType].storage[objectId].fillLevel = amounts[fillType].storage[objectId].fillLevel + Utils.getNoNil(fillLevel, 0);											
						end;
					end;							
				end;
				---------			
				if object.spec_objectStorage ~= nil and object.spec_objectStorage.objectInfos ~= nil then	
					local objectInfos = object:getObjectStorageObjectInfos();
					if objectInfos ~= nil and #objectInfos > 0 then						
						for o=1, #objectInfos do
							if objectInfos[o].objects ~= nil and #objectInfos[o].objects > 0 then
								if #objectInfos[o].objects == 1 and objectInfos[o].numObjects ~= 1 then --mp
									for oS=1, #objectInfos[o].objects do										
										setObjectStorage(objectInfos[o].objects[oS], objectInfos[o].numObjects);											
									end;
								else
									for oS=1, #objectInfos[o].objects do										
										setObjectStorage(objectInfos[o].objects[oS]);											
									end;
								end;
							end;
						end;
					end;							
				elseif object.spec_objectStorageMod ~= nil and object.spec_objectStorageMod.storedObjects ~= nil then --later by areas mods
					--for o=1, #object.spec_objectStorageMod.storedObjects do
					--	if object.spec_objectStorageMod.storedObjects[o].storageAreasByFillType ~= nil then
					--		for oa=1, #object.spec_objectStorageMod.storedObjects[o].storageAreasByFillType do
					--			setObjectStorage(object.spec_objectStorageMod.storedObjects[o]);
					--		end;					
					--	end;						
					--end;
				elseif object.spec_bunkerSilo ~= nil and object.spec_bunkerSilo.bunkerSilo ~= nil then
					setObjectBunker(object.spec_bunkerSilo.bunkerSilo);
				end;
			end;
		end;		
	end;	
		
	if sort ~= nil and sort then
		function comp(w1,w2)		
			if w1.objectName < w2.objectName then
				return true;
			end;				
		end;		
		for index, _ in pairs(amounts) do
			table.sort(amounts[index].storage, comp);			
		end;
	end;
	return amounts;
end;

function FTAP_DisplaySetGet:setNumOfAnimals(fillTypesTable)
	local playerFarmId = g_currentMission.hlUtils.getPlayerFarmId();
	local animalSystem = g_currentMission.animalSystem;
	local fillTypes = fillTypesTable or FTAP_DisplaySetGet.fillTypes;
	if animalSystem ~= nil then		
		local animals = {};
		for _,fillType in pairs (fillTypes) do
			if fillType.isAnimal then
				local subTypeIndex = animalSystem:getSubTypeIndexByFillTypeIndex(fillType.index);
				if subTypeIndex ~= nil then					
					local subType = animalSystem:getSubTypeByIndex(subTypeIndex);
					if subType ~= nil then
						local numAnimals = 0;
						for _, placeable in ipairs(g_currentMission.husbandrySystem.placeables) do
							if placeable ~= nil and placeable:getOwnerFarmId() == playerFarmId and placeable:getAnimalTypeIndex() == subType.typeIndex then
								local clusters = placeable:getClusters();
								local clusterNumAnimals = 0;
								if clusters ~= nil then									
									for _, cluster in ipairs(clusters) do
										if cluster ~= nil then
											if cluster.subTypeIndex == subTypeIndex then
												numAnimals = numAnimals + cluster.numAnimals;
												clusterNumAnimals = clusterNumAnimals + cluster.numAnimals;
											end;
										end;										
									end								
								end;
								local objectId = placeable.rootNode or placeable.nodeId;
								animals[#animals+1] = {numAnimals=clusterNumAnimals, objectName=FTAP_DisplaySetGet:getNameMissingXmlText(Utils.getNoNil(placeable:getName(), nil), "Animals"), nodeId=Utils.getNoNil(objectId, 0), mapHotspot=placeable.spec_hotspots};								
							end;
						end;
						fillType.numAnimals = numAnimals;						
						fillType.animals = animals;
						animals = {};
					end;					
				end;				
			end;		
		end;		
	else
		FTAP_DisplaySetGet:resetFillTypes(fillTypes, "animals");
	end;
	return fillTypes;
end;

function FTAP_DisplaySetGet:getPallets(sort)
	local playerFarmId = g_currentMission.hlUtils.getPlayerFarmId();
	local pallets = {};
	if g_currentMission.ownedItems ~= nil then			
		for key, value in pairs (g_currentMission.ownedItems) do
			if key ~= nil and value ~= nil and value.items ~= nil and type(value.items) == "table" then			
				for _, item in pairs(value.items) do				
					if item.ownerFarmId == playerFarmId then
						if item ~= nil and type(item) == "table" and item.typeName ~= nil and (string.find(item.typeName:lower(), "pallet")) then							
							if item.spec_fillUnit ~= nil and item.spec_fillUnit.fillUnits ~= nil and item.spec_fillUnit.fillUnits[1] ~= nil and item.spec_fillUnit.fillUnits[1].fillType ~= nil then
								local objectId = item.rootNode or item.nodeId;
								local fillType = item.spec_fillUnit.fillUnits[1].fillType;						
								local fillLevel = item.spec_fillUnit.fillUnits[1].fillLevel;								
								if pallets[fillType] == nil then pallets[fillType] = {fillLevel=0,total=0,nodeId={}};end;
								pallets[fillType].fillLevel = Utils.getNoNil(pallets[fillType].fillLevel, 0) + fillLevel;
								pallets[fillType].total = Utils.getNoNil(pallets[fillType].total, 0) + 1;
								pallets[fillType].nodeId[#pallets[fillType].nodeId+1] = {fillLevel=fillLevel,nodeId=objectId};															
							end;						
						end;
					end;
				end;
			end;
		end;		
	end;
	if sort ~= nil and sort then
		function comp(w1,w2)		
			if w1.total > w2.total then
				return true;
			end;				
		end;		
		table.sort(pallets, comp);		
	end;
	return pallets;
end;

function FTAP_DisplaySetGet:getBales(sort)
	local playerFarmId = g_currentMission.hlUtils.getPlayerFarmId();
	local bales = {};
	if g_currentMission.itemSystem.itemsToSave ~= nil then
		for _, items in pairs(g_currentMission.itemSystem.itemsToSave) do
			if items.item.ownerFarmId == playerFarmId then	 
				if items.className == "Bale" then
					local fillLevel = items.item.fillLevel;				
					local fillType = items.item.fillType;
					local typ = "SQUAREBALE";
					if items.item.isRoundbale then typ = "ROUNDBALE";end;					
					local objectId = items.item.rootNode or items.item.nodeId;
					if bales[fillType] == nil then bales[fillType] = {fillLevel=0,total=0,totalS=0,totalR=0,totalF=0,percentF=0,nodeId={}};end;
					bales[fillType].fillLevel = Utils.getNoNil(bales[fillType].fillLevel, 0) + fillLevel;
					bales[fillType].total = Utils.getNoNil(bales[fillType].total, 0) + 1;
					if typ == "SQUAREBALE" then bales[fillType].totalS = Utils.getNoNil(bales[fillType].totalS, 0) + 1;else bales[fillType].totalR = Utils.getNoNil(bales[fillType].totalR, 0) + 1;end;
					if items.item.isFermenting then
						bales[fillType].percentF = Utils.getNoNil(bales[fillType].percentF, 0) + Utils.getNoNil(items.item.fermentingPercentage, 0);
						bales[fillType].totalF = Utils.getNoNil(bales[fillType].totalF) + 1;
					end;
					bales[fillType].nodeId[#bales[fillType].nodeId+1] = {fillLevel=fillLevel,nodeId=objectId,typ=typ,percentF=Utils.getNoNil(items.item.fermentingPercentage, 0)};								
				end;			
			end;		
		end;	
	end;	
	if sort ~= nil and sort then
		function comp(w1,w2)		
			if w1.total > w2.total then
				return true;
			end;				
		end;		
		table.sort(bales, comp);		
	end;
	return bales;
end;

function FTAP_DisplaySetGet:resetFillTypes(fillTypesTable, typ)
	local fillTypes = fillTypesTable or FTAP_DisplaySetGet.fillTypes;
	if fillTypes == nil then return;end;
	for _,fillType in pairs (fillTypes) do
		if typ == "all" then
			fillType.numAnimals = 0;						
			fillType.animals = {};
			fillType.pallets = {};
			fillType.bales = {};
		else
			if typ == "animals" then
				fillType.numAnimals = 0;
			end;
			fillType[typ] = {};
		end;
	end;	
end;

function FTAP_DisplaySetGet:resetAllData()
	if FTAP_DisplaySetGet.fillTypes == nil then return;end;
	FTAP_DisplaySetGet:resetFillTypes(nil, "all");
	local box = g_currentMission.hlHudSystem.hlBox:getData("FTAP_Display_Box");
	if box ~= nil then
		if box.ownTable.viewBales then FTAP_DisplaySetGet:setBalesAmount();end;
		if box.ownTable.viewPal then FTAP_DisplaySetGet:setPalletsAmount();end;
		if box.ownTable.viewAnimals then FTAP_DisplaySetGet:setNumOfAnimals();end;
	end;	
	FTAP_DisplaySetGet:setFillTypesAmount();
end;

function FTAP_DisplaySetGet:setPalletsAmount(fillTypesTable)
	local pallets = FTAP_DisplaySetGet:getPallets();
	local fillTypes = fillTypesTable or FTAP_DisplaySetGet.fillTypes;
	if pallets ~= nil then		
		for _,fillType in pairs (fillTypes) do
			if pallets[fillType.index] ~= nil then
				fillType.pallets = pallets[fillType.index];
			else
				fillType.pallets = {};
			end;
		end;
	else
		FTAP_DisplaySetGet:resetFillTypes(fillTypes, "pallets");
	end;
	return fillTypes;
end;

function FTAP_DisplaySetGet:setBalesAmount(fillTypesTable)
	local bales = FTAP_DisplaySetGet:getBales();
	local fillTypes = fillTypesTable or FTAP_DisplaySetGet.fillTypes;
	if bales ~= nil then		
		for _,fillType in pairs (fillTypes) do
			if bales[fillType.index] ~= nil then
				fillType.bales = bales[fillType.index];
			else
				fillType.bales = {};
			end;
		end;		
	else
		FTAP_DisplaySetGet:resetFillTypes(fillTypes, "bales");
	end;	
	return fillTypes;
end;

function FTAP_DisplaySetGet:setFillTypesPrice(fillTypesTable, maxBestPrice)
	local prices = FTAP_DisplaySetGet:getPrices(true);
	if prices ~= nil and #prices > 0 then
		local fillTypes = fillTypesTable or FTAP_DisplaySetGet.fillTypes;		
		local bestPrices = {};
		local greatDemand = {};
		for _,fillType in pairs (fillTypes) do
			if prices[fillType.index] ~= nil then
				for p=1, maxBestPrice or 4 do
					if prices[fillType.index][p] == nil then break;end;
					if p == 1 then fillType.priceTrend = prices[fillType.index][p].priceTrend;fillType.bestPrice = Utils.getNoNil(prices[fillType.index][p].price, 0);end;
					table.insert(bestPrices, prices[fillType.index][p])
					if prices[fillType.index][p].priceTrend == "GreatDemand" then
						table.insert(greatDemand, prices[fillType.index][p]);
					end;
				end;
			end;
			fillType.greatDemand = greatDemand;
			fillType.bestPrices = bestPrices;
			greatDemand = {};
			bestPrices = {};
		end;		
		return fillTypes;
	end;
	return fillTypes;
end;

function FTAP_DisplaySetGet:setChangeFillTypesPrice()
	
	for _,fillType in pairs (FTAP_DisplaySetGet.fillTypes) do
		fillType.monthPrices = FTAP_DisplaySetGet:getMonthPrices(fillType.desc);
	end;
	FTAP_DisplaySetGet:getPrices();
end;

function FTAP_DisplaySetGet:setFillTypesAmount(fillTypesTable)
	local amounts = FTAP_DisplaySetGet:getAmounts(true);	
	local fillTypes = fillTypesTable or FTAP_DisplaySetGet.fillTypes;	
	if amounts ~= nil and #amounts > 0 then
		local fillTypes = fillTypesTable or FTAP_DisplaySetGet.fillTypes;	
		for _,fillType in pairs (fillTypes) do
			if amounts[fillType.index] ~= nil then
				fillType.amounts = amounts[fillType.index];			
			else
				fillType.amounts = {};
			end;								
		end;		
	else
		FTAP_DisplaySetGet:resetFillTypes(fillTypes, "amounts");
	end;
	return fillTypes;
end;

function FTAP_DisplaySetGet:showInGameMenuFrame(frame, page, fillType, global, change, forceMouse)	
	if frame == nil or g_gui.frames[frame] == nil or change > 1 then return;end;
	local change = change or 0;
	function setForceMouse()		
		g_currentMission.hlUtils.mouseOnOff(false, false); --force mouseOff			
	end;
	if frame == "ingameMenuGameStats" then		
		if (global ~= nil and global) or page == nil then
			if forceMouse == nil or forceMouse then setForceMouse();end; --force mouseOff
			local show = g_gui:showGui("InGameMenu");			
			local pageId = show.parent.pagingElement:getPageIdByElement(show.parent.pageStatistics);
			local pageIndex = show.parent.pagingElement:getPageMappingIndex(pageId);
			show.parent.pageSelector:setState(pageIndex, true);				
		else
			if page ~= nil then
				if forceMouse == nil or forceMouse then setForceMouse();end; --force mouseOff
				local show = g_gui:showGui("InGameMenu");
				local pageId = show.parent.pagingElement:getPageIdByElement(show.parent.pageStatistics);
				local pageIndex = show.parent.pagingElement:getPageMappingIndex(pageId);					
				
				show.parent.pageSelector:setState(pageIndex, true);					
								
				local pageElement = show.parent.pagingElement:getPageById(pageId);
				
				if page == "SUB_CATEGORY.PRICES" then
					InGameMenuStatisticsFrame.onClickPrices(pageElement.element);					
					function searchFillType()
						for f=1, #pageElement.element.fillTypes do
							if pageElement.element.fillTypes[f] ~= nil then
								for i=1, #pageElement.element.fillTypes[f] do
									if fillType.index == pageElement.element.fillTypes[f][i].index then
										if pageElement.element.fillTypes[f][i].showOnPriceTable then return f, i;else return 0,0;end;
									end;
								end;
							end;												
						end;
						return 0,0;
					end;
					if fillType ~= nil and fillType.index ~= nil then
						local selectIndex, selectItem = searchFillType();						
						if selectIndex ~= 0 and selectItem ~= 0 then pageElement.element.productList:setSelectedItem(selectIndex, selectItem);end;						
					end;
				end;					
			elseif change == 0 then
				FTAP_DisplaySetGet:showInGameMenuFrame(frame, page, fillType, true, change+1, forceMouse)
			end;
		end;
	end;	
end;

function FTAP_DisplaySetGet:setGlobalFunctions()
	g_currentMission.hlUtils.globalFunction["FS25_FillTypeAmountPriceDisplay"] = {
		getAmounts =  function(args)return FTAP_DisplaySetGet:getAmounts(args);end;
		getPrices =  function(args)return FTAP_DisplaySetGet:getPrices(args);end;
		getSellingStations =  function(args)return FTAP_DisplaySetGet:getSellingStations(args);end;
		getBales =  function(args)return FTAP_DisplaySetGet:getBales(args);end;
		getPallets =  function(args)return FTAP_DisplaySetGet:getPallets(args);end;
	};	
end;