FTAP_Display_DrawBox = {};

function FTAP_Display_DrawBox.setBox(args)
	if args == nil or type(args) ~= "table" or args.typPos == nil or args.inArea == nil then return;end;
	local box = g_currentMission.hlHudSystem.box[args.typPos];
	if box == nil then return;end;
	
	local inArea = args.inArea
	local boxNumber = args.typPos;
	
	local x, y, w, h = box:getScreen();	
	
	local mW = w/2;
	local mH = h/2;
	
	local distance = box:getSize( {"distance"} ); 
	local difW = distance.textWidth --default width
	local difH = distance.textHeight; --default height	
	local size = box.screen.size.zoomOutIn.text[1];
	local difSize = 0.0015;	
	
	local overlaySubFillTypesGroup = g_currentMission.hlUtils.overlays["LS_FillTypes"]["subFillTypes"];
	local overlayFillTypesGroup = g_currentMission.hlUtils.overlays["LS_FillTypes"]["fillTypes"];
	local overlayFillTypesByName = g_currentMission.hlUtils.overlays.byName["LS_FillTypes"]["fillTypes"];
	local overlayDefaultGroup = box.overlays.icons["defaultIcons"]["box"];
	local overlayDefaultByName = box.overlays.icons.byName["defaultIcons"]["box"];
	local overlay = nil;
	local tempOverlay = nil;
	local markerOpen = KeyboardHelper.getDisplayKeyName(273.0);
	
	function needsUpdate()		
		if box.needsUpdate or box.ownTable.lineHeight == nil then
			box.ownTable.lineHeight = getTextHeight(size, utf8Substr("Äg", 0))+distance.textLine;
			box.ownTable.iconWidth, box.ownTable.iconHeight = box:getOptiWidthHeight( {typ="icon", height=box.ownTable.lineHeight-distance.textLine-(difH), width=w-(difW*2)} );
			box.ownTable.priceWidth = getTextWidth(size, utf8Substr(g_i18n:formatMoney(9999991, 0, true, false), 0));
			box.ownTable.amountWidth = getTextWidth(size, utf8Substr(g_i18n:formatVolume(99999999, 0), 0));			
		end;		
		box.needsUpdate = false;
	end;	
	needsUpdate();
	
	if not g_currentMission.hlUtils.isMouseCursor then box.isSetting = false;end;	
	
	local iconColor = nil;
	local iconWidth = box.ownTable.iconWidth;
	local iconHeight = box.ownTable.iconHeight;
	local iconWidthS = iconWidth/1.3;
	local iconHeightS = iconHeight/1.3;
	local nextPosX = x+difW;
	local nextPosY = y;		
	local nextIconPosX = x+difW;
	local nextLeftPosX = nextPosX;
	local nextRightPosX = x+w-difW;
	nextPosY = nextPosY+(h)-(box.ownTable.lineHeight)-difH;
	local openGroup = FTAP_DisplaySetGet:setViewFillTypes(box);
	box.screen.bounds[4] = #FTAP_DisplaySetGet.viewFillTypes+1; -- +1 for Imaginäre Line wenn untergruppe an ist (viewAmountStorages/viewBestPriceStations etc.
	if box.viewExtraLine then box.screen.bounds[4] = box.screen.bounds[4]+1;end;
	
	--FTAP_Display.testString[1] = "bounds1: ".. tostring(box.screen.bounds[1]);
	--FTAP_Display.testString[2] = "bounds2: ".. tostring(box.screen.bounds[2]);
	--FTAP_Display.testString[3] = "bounds4: ".. tostring(box.screen.bounds[4]);
	
	function setInfoHelpText(txt, maxLine, txtColor) --global or mod
		if box.isSetting and box.settingTyp == 1 and g_currentMission.hlHudSystem.infoDisplay.on then --insert more text
			box:setMoreInfo(tostring(txt));
		else
			g_currentMission.hlHudSystem:addTextDisplay( {txt=tostring(txt), maxLine=maxLine, txtColor=txtColor} ); 
		end;
	end;
	
	if box.screen.bounds[1] > 0 then
		--warningLine--
		function setWarningLineIcon()
			overlay = overlayDefaultGroup[overlayDefaultByName["right"]];
			g_currentMission.hlUtils.setOverlay(overlay, x+w-((iconWidth/1.5/2)), nextPosY-0.003, iconWidth/1.5, iconHeight/1.5);
			g_currentMission.hlUtils.setBackgroundColor(overlay, g_currentMission.hlUtils.getColor(box.overlays.color.warning, true));
			local inIconArea = overlay.mouseInArea();
			if inIconArea and box.isHelp then setInfoHelpText(string.format(box:getI18n("hl_infoDisplay_viewNotAllIcons"), "Box"), 0);end;
			if g_currentMission.hlUtils.runsTimer("1sec", true) then
				overlay:render();
			end;
		end;
		--warningLine--
		--viewExtraLineSetting--
		function viewExtraLineSetting()
			if nextPosY < y then return;end;
			local setWarningLine = false;
			local inIconArea = false;
			if nextIconPosX+iconWidth < x+w then
				overlay = overlayDefaultGroup[overlayDefaultByName["lineHorizontalUpDown"]];
				tempOverlay = box.overlays.bgLine;
				if overlay ~= nil and tempOverlay ~= nil then
					g_currentMission.hlUtils.setOverlay(overlay, nextIconPosX, nextPosY, iconWidth, iconHeight);
					inIconArea = overlay.mouseInArea();
					if inIconArea then g_currentMission.hlUtils.setBackgroundColor(overlay, g_currentMission.hlUtils.getColor(box.overlays.color.inArea, true));else g_currentMission.hlUtils.setBackgroundColor(overlay, g_currentMission.hlUtils.getColor(box.overlays.color.text, true));end;
					overlay:render();
					if inIconArea and box.isHelp then setInfoHelpText(string.format(box:getI18n("hl_infoDisplay_lineDistance"), string.format("%1.2f", box.screen.size.distance.textLine/box.screen.pixelH)));end;
					if not g_currentMission.hlUtils:disableInArea() and inArea and inIconArea then box:setClickArea( {overlay.x, overlay.x+overlay.width, overlay.y, overlay.y+overlay.height, onClick=FTAP_Display_MouseKeyEventsBox.onClickArea, whatClick="FTAP_Display_Box", typPos=boxNumber, whereClick="settingLineDistance_", ownTable={}} );end;
					nextIconPosX = nextIconPosX+iconWidth+difW;
				end;
			else
				setWarningLine = true;
			end;
			if nextIconPosX+(iconWidth*3) < x+w then
				setTextColor(1, 1, 1, 1);
				renderText(nextIconPosX+difW, nextPosY, size-0.0015, tostring(" |S:"..string.format("%1.1f", size*1000)));
			else
				setWarningLine = true;
			end;
			
			if setWarningLine then
				setWarningLineIcon();
			end;
			nextPosY = nextPosY-box.ownTable.lineHeight;
		end;
		--viewExtraLineSetting--
		--viewExtraLine--
		function viewExtraLine()
			if nextPosY < y then return;end;			
			local onOffTxt = g_i18n:getText("ui_on").. "/".. g_i18n:getText("ui_off");
			local setWarningLine = false;
			local inIconArea = false;
			function setOverlay(whereClick, color, marked)
				if color == nil then color = box.overlays.color.notActive;end;
				g_currentMission.hlUtils.setOverlay(overlay, nextIconPosX, nextPosY, iconWidth, iconHeight);
				inIconArea = overlay.mouseInArea();
				g_currentMission.hlUtils.setBackgroundColor(overlay, g_currentMission.hlUtils.getColor(color, true));
				overlay:render();
				if not g_currentMission.hlUtils:disableInArea() and inArea and inIconArea and whereClick ~= nil then box:setClickArea( {overlay.x, overlay.x+overlay.width, overlay.y, overlay.y+overlay.height, onClick=FTAP_Display_MouseKeyEventsBox.onClickArea, whatClick="FTAP_Display_Box", typPos=boxNumber, whereClick=whereClick, ownTable={}} );end;
				if marked ~= nil and marked then
					setTextColor(unpack(g_currentMission.hlUtils.getColor(box.overlays.color.warning, true)));
					renderText(nextIconPosX, nextPosY+(iconHeight/1.6), size, tostring("*"));
					setTextColor(1, 1, 1, 1);
				end;
				nextIconPosX = nextIconPosX+iconWidth+difW;
				iconColor = nil;				
			end;
			if nextIconPosX+iconWidth < x+w then
				overlay = overlayDefaultGroup[overlayDefaultByName["search"]];
				if overlay ~= nil then
					if box.searchFilter:len() > 0 then iconColor = box.overlays.color.on;end;
					setOverlay("search_", iconColor);
					if inIconArea and box.isHelp then setInfoHelpText(g_i18n:getText("box_searchFilterInfo"), 0);end;
				end;				
			else
				setWarningLine = true;
			end;
			if not setWarningLine and nextIconPosX+iconWidth < x+w then
				overlay = overlayDefaultGroup[overlayDefaultByName["flip"]];
				if overlay ~= nil then
					if box.ownTable.sortBy > 1 then iconColor = box.overlays.color.on;end;
					setOverlay("sortBy_", iconColor);
					local sortByWhat = g_i18n:getText("button_no"); 
					if box.ownTable.sortBy == 2 then sortByWhat = "NAME";elseif box.ownTable.sortBy == 3 then sortByWhat = g_i18n:getText("info_fillLevel");elseif box.ownTable.sortBy == 4 then sortByWhat = g_i18n:getText("ui_sellPrices");elseif box.ownTable.sortBy == 5 then sortByWhat = g_i18n:getText("ui_gameMode_seasonal").. "/".. g_i18n:getText("ui_month");elseif box.ownTable.sortBy == 6 then sortByWhat = g_i18n:getText("ui_buyPrices").. "=".. g_i18n:getText("highestPrice");end;
					if inIconArea then setInfoHelpText(g_i18n:getText("button_sortTable").. "... ".. g_i18n:getText("ui_contractsActive").. ": ".. tostring(sortByWhat));end;
				end;				
			else
				setWarningLine = true;
			end;
			if not setWarningLine and nextIconPosX+iconWidth < x+w then
				overlay = overlayDefaultGroup[overlayDefaultByName["priceTrend"]];
				if overlay ~= nil then					
					if box.ownTable.viewPriceTrend then iconColor = box.overlays.color.on;end;					
					setOverlay("viewPriceTrend_", iconColor);					
					local addText = g_i18n:getText("button_showFluctuations").. " ".. tostring(onOffTxt);
					if inIconArea and box.isHelp then setInfoHelpText(addText);end;					
				end;				
			else
				setWarningLine = true;
			end;
			if not setWarningLine and nextIconPosX+iconWidth < x+w then
				overlay = overlayDefaultGroup[overlayDefaultByName["moneyEuro"]];
				if overlay ~= nil then
					if box.ownTable.viewPrice then iconColor = box.overlays.color.on;end;
					setOverlay("viewPrice_", iconColor);
					local addText = g_i18n:getText("button_showActualPrices").. " ".. tostring(onOffTxt).. "\n".. g_i18n:getText("box_viewPricesInfo").. "\n".. string.format(g_i18n:getText("updateTact"), box.ownTable.priceUpdateTimer).. "\n".. g_i18n:getText("object_maphotspot").. "\n".. g_i18n:getText("object_teleport");
					if inIconArea and box.isHelp then setInfoHelpText(addText, 0);end;
				end;
			else
				setWarningLine = true;
			end;
			if not setWarningLine and nextIconPosX+iconWidth < x+w then
				overlay = overlayDefaultGroup[overlayDefaultByName["fillAmount"]];
				if overlay ~= nil then
					if box.searchFilter:len() > 0 then iconColor = box.overlays.color.warning;elseif box.ownTable.viewFillAmounts then iconColor = box.overlays.color.on;end;
					setOverlay("viewFillAmounts_", iconColor);
					local addText = g_i18n:getText("shop_fruitTypes").. "/".. g_i18n:getText("info_fillLevel").. " > 0 ".. tostring(onOffTxt).. "\n".. g_i18n:getText("box_viewFillEmptyAmountsInfo").. "\n".. string.format(g_i18n:getText("updateTact"), box.ownTable.amountUpdateTimer).. "\n".. g_i18n:getText("object_maphotspot").. "\n".. g_i18n:getText("object_teleport");
					if inIconArea and box.isHelp then setInfoHelpText(addText, 0);end;					
				end;					
			else
				setWarningLine = true;
			end;
			if not setWarningLine and nextIconPosX+iconWidth < x+w then
				overlay = overlayDefaultGroup[overlayDefaultByName["emptyAmount"]];
				if overlay ~= nil then
					if box.searchFilter:len() > 0 then iconColor = box.overlays.color.warning;elseif box.ownTable.viewEmptyAmounts then iconColor = box.overlays.color.on;end;
					setOverlay("viewEmptyAmounts_", iconColor);
					local addText = g_i18n:getText("shop_fruitTypes").. "/".. g_i18n:getText("info_fillLevel").. " = 0 ".. tostring(onOffTxt).. "\n".. g_i18n:getText("box_viewFillEmptyAmountsInfo").. "\n".. string.format(g_i18n:getText("updateTact"), box.ownTable.amountUpdateTimer).. "\n".. g_i18n:getText("object_maphotspot").. "\n".. g_i18n:getText("object_teleport");
					if inIconArea and box.isHelp then setInfoHelpText(addText, 0);end;					
				end;					
			else
				setWarningLine = true;
			end;
			if not setWarningLine and nextIconPosX+iconWidth < x+w then
				overlay = overlayDefaultGroup[overlayDefaultByName["wheat"]];
				if overlay ~= nil then
					local moreTxt = "";
					if box.ownTable.viewFillType == 2 then iconColor = box.overlays.color.on;moreTxt = "(Icon)";elseif box.ownTable.viewFillType == 3 then iconColor = box.overlays.color.warning;moreTxt = "(Icon + Name)";else moreTxt = "(Name)";end;					
					if box.ownTable.viewShowOnPriceTable then moreTxt = moreTxt.. "\n".. string.format(g_i18n:getText("box_viewShowOnPriceTableInfo"), g_i18n:getText("ui_off"));else moreTxt = moreTxt.. "\n".. string.format(g_i18n:getText("box_viewShowOnPriceTableInfo"), g_i18n:getText("ui_on"));end;
					setOverlay("viewFillType_", iconColor, box.ownTable.viewShowOnPriceTable);	
					local addText = g_i18n:getText("shop_fruitTypes").. "/Name,Icon,Icon + Name ".. moreTxt;
					if inIconArea and box.isHelp then setInfoHelpText(addText, 0);end;
				end;					
			else
				setWarningLine = true;
			end;			
			if not setWarningLine and nextIconPosX+iconWidth < x+w then
				overlay = overlayDefaultGroup[overlayDefaultByName["production"]];
				if overlay ~= nil then
					if box.ownTable.viewProductions then iconColor = box.overlays.color.on;end;					
					setOverlay("viewProductions_", iconColor);	
					if inIconArea and box.isHelp then setInfoHelpText(g_i18n:getText("box_viewProductionsInfo").. "\n".. string.format(g_i18n:getText("updateTact"), box.ownTable.amountUpdateTimer).. "\n".. g_i18n:getText("object_maphotspot").. "\n".. g_i18n:getText("object_teleport"), 0);end;					
				end;					
			else
				setWarningLine = true;
			end;
			if not setWarningLine and nextIconPosX+iconWidth < x+w then
				overlay = overlayDefaultGroup[overlayDefaultByName["animals"]];
				if overlay ~= nil then
					if box.ownTable.viewAnimals then iconColor = box.overlays.color.on;end;
					setOverlay("viewAnimals_", iconColor);
					local addText =	g_i18n:getText("ui_animalInformation").. "/".. g_i18n:getText("button_easy").. " ".. tostring(onOffTxt).. "\n".. string.format(g_i18n:getText("updateTact"), box.ownTable.animalsUpdateTimer).. "\n".. g_i18n:getText("object_maphotspot").. "\n".. g_i18n:getText("object_teleport"); --"\nKlicke auf ein Object für MapHotspot (Mittlere Maustaste)\nTeleport zu Object (Rechte Maustaste) *Wenn vorhanden*";
					if inIconArea and box.isHelp then setInfoHelpText(addText, 0);end;
				end;					
			else
				setWarningLine = true;
			end;
			if not setWarningLine and nextIconPosX+iconWidth < x+w then
				overlay = overlayDefaultGroup[overlayDefaultByName["pallete"]];
				if overlay ~= nil then					
					if box.ownTable.viewPal then iconColor = box.overlays.color.on;end;
					setOverlay("viewPal_", iconColor);	
					if inIconArea and box.isHelp then setInfoHelpText(g_i18n:getText("box_viewPalletsInfo").. "\n".. g_i18n:getText("performance_attention").. "\n".. string.format(g_i18n:getText("updateTact"), box.ownTable.palletsUpdateTimer).. "\n".. g_i18n:getText("object_maphotspot"), 0);end;
				end;
			else
				setWarningLine = true;	
			end;
			if not setWarningLine and nextIconPosX+iconWidth < x+w then
				overlay = overlayDefaultGroup[overlayDefaultByName["bale"]];
				if overlay ~= nil then
					if box.ownTable.viewBales then iconColor = box.overlays.color.on;end;
					setOverlay("viewBales_", iconColor);	
					if inIconArea and box.isHelp then setInfoHelpText(g_i18n:getText("box_viewBalesInfo").. "\n".. g_i18n:getText("performance_attention").. "\n".. string.format(g_i18n:getText("updateTact"), box.ownTable.balesUpdateTimer).. "\n".. g_i18n:getText("object_maphotspot"), 0);end;
				end;					
			else
				setWarningLine = true;
			end;			
			if not setWarningLine and nextIconPosX+iconWidth < x+w then
				overlay = overlayDefaultGroup[overlayDefaultByName["closeLines"]];
				if overlay ~= nil then
					if openGroup ~= nil and openGroup then iconColor = box.overlays.color.warning;end;
					if openGroup ~= nil and not openGroup then
						setOverlay(nil, iconColor);
					else
						setOverlay("closeAllGroupLines_", iconColor);
					end;
					if inIconArea and box.isHelp then setInfoHelpText(g_i18n:getText("box_closeGroupLines"));end;
				end;					
			else
				setWarningLine = true;
			end;
			if setWarningLine then
				setWarningLineIcon();
			end;
			nextPosY = nextPosY-box.ownTable.lineHeight;
		end;
		if box.viewExtraLine and not box.isSetting then viewExtraLine();elseif box.viewExtraLine and box.isSetting then viewExtraLineSetting();end;
		--viewExtraLine--		
		local color = nil;
		local maxTxtWidth = w-(difW*2);
		local bounds1 = box.screen.bounds[1];
		local bounds2 = box.screen.bounds[2];
		local extraLineBounds = 0;
		for t=bounds1, bounds2 do			
			if nextPosY < y then break;end;			
			local trimReplaceText = ".";
			local trimText = 0;
			if FTAP_DisplaySetGet.viewFillTypes[t] ~= nil then
				local fillType = FTAP_DisplaySetGet.viewFillTypes[t];
				
				local canViewMonthPrice = fillType.monthPrices ~= nil and fillType.monthPrices[1] ~= nil and fillType.monthPrices[1].hasFluctuations;
				local notFluctuations = fillType.monthPrices ~= nil and fillType.monthPrices[1] ~= nil and not fillType.monthPrices[1].hasFluctuations;
				local isCurrentPeriod = canViewMonthPrice and ((g_currentMission.environment.currentPeriod == fillType.monthPrices[1].month) or (fillType.monthPrices[1].doubleBestMonth and g_currentMission.environment.currentPeriod == fillType.monthPrices[2].month));
				local bestPriceReady = (canViewMonthPrice and fillType.bestPrices[1] ~= nil and fillType.bestPrices[1].price >= fillType.monthPrices[1].price) or (canViewMonthPrice and fillType.monthPrices[1].doubleBestMonth and fillType.bestPrices[1] ~= nil and fillType.bestPrices[1].price >= fillType.monthPrices[2].price);
				local isDemand = fillType.priceTrend == "GreatDemand" or fillType.greatDemand[1] ~= nil;
				
				if isDemand then 
					color = g_currentMission.hlUtils.getColor("ls15", true);
				else 
					--if bestPriceReady then color = g_currentMission.hlUtils.getColor(box.overlays.color.on, true);elseif isCurrentPeriod then color = g_currentMission.hlUtils.getColor("yellowGreen", true);else color = g_currentMission.hlUtils.getColor(box.overlays.color.text, true);end;
					if bestPriceReady then color = g_currentMission.hlUtils.getColor(box.overlays.color.on, true);else color = g_currentMission.hlUtils.getColor(box.overlays.color.text, true);end;
				end;
				if t == box.screen.bounds[1] and not box.viewExtraLine and box.searchFilter:len() > 0 then
					local text = g_currentMission.hlUtils.getTxtToWidth("*Filter On*", size, w-(difW*2), false, ".");
					setTextColor(unpack(g_currentMission.hlUtils.getColor(box.overlays.color.title, true)));
					renderText(nextLeftPosX, nextPosY, size, tostring(text));
					setTextColor(1, 1, 1, 1);
					nextPosY = nextPosY-box.ownTable.lineHeight;
					if nextPosY < y then break;end;
				end;				
								
				local canNextView = true;
				local lineWidth = w-(difW*2);
				
				--marked fillType--
				if fillType.isMarked then
					overlay = overlayDefaultGroup[overlayDefaultByName["markedLine"]];
					if overlay ~= nil then
						g_currentMission.hlUtils.setOverlay(overlay, x, nextPosY-(distance.textLine/2), w, box.ownTable.lineHeight);
						overlay:render();
					end;
					--overlay = overlayDefaultGroup[overlayDefaultByName["markedDesiredSellPrice"]];
					--if overlay ~= nil then
					--	g_currentMission.hlUtils.setOverlay(overlay, x-(iconWidth/2), nextPosY, iconWidth, iconHeight);
					--	overlay:render();
					--end;
				end;
				--marked fillType--
				
				--desiredSellPrice fillType--
				if fillType.desiredSellPrice > 0 then
					--setTextColor(unpack(g_currentMission.hlUtils.getColor(box.overlays.color.columText2, true)));
					--renderText(x-0.001, nextPosY, size, tostring("|"));
					--setTextColor(1, 1, 1, 1);
				end;
				--desiredSellPrice fillType--
				
				---fillType Price Trend---
				if box.ownTable.viewPriceTrend and canNextView then					
					if lineWidth >= iconWidthS then						
						canNextView = true;
						overlay = overlayDefaultGroup[overlayDefaultByName["priceTrend".. fillType.priceTrend]];
						if not fillType.isAnimal and overlay ~= nil then						
							g_currentMission.hlUtils.setOverlay(overlay, nextRightPosX-iconWidthS, nextPosY, iconWidthS, iconHeightS);
							overlay:render();						
						end;
						lineWidth = lineWidth-iconWidthS;
						nextRightPosX = nextRightPosX-iconWidthS;
						canNextView = lineWidth > iconWidth;
					else
						canNextView = false;
					end;					
				end;
				---fillType Price Trend---
				
				---fillType Price---
				if box.ownTable.viewPrice and canNextView then
					local bestPrice = tostring(g_i18n:formatMoney(fillType.bestPrice, 0, true, false));
					if fillType.bestPrices[1] == nil and box.ownTable.changeViewPrices[1] < 3 then --change for unknown price bug !
						box.ownTable.changeViewPrices[1] = box.ownTable.changeViewPrices[1]+1;
						FTAP_DisplaySetGet:setChangeFillTypesPrice();
						bestPrice = tostring(g_i18n:formatMoney(fillType.bestPrice, 0, true, false));
					else
						box.ownTable.changeViewPrices[1] = 3;
					end;
					if fillType.bestPrices[1] == nil or fillType.isAnimal then bestPrice = "-";end;					
					if fillType.bestPrice > 0 then
						bestPrice = g_currentMission.hlUtils.getTxtToWidth(bestPrice, size, lineWidth, true, ".");
					end;
					if fillType.viewBestPriceStations and fillType.bestPrices[1] ~= nil then						
						setTextBold(true);
						--set folder Icon is better ?
					else
						setTextBold(false);
					end;					
					setTextColor(unpack(color));
					setTextAlignment(2);
					if nextRightPosX > nextLeftPosX then 
						setTextAlignment(2);
					end;
					renderText(nextRightPosX, nextPosY, size, tostring(bestPrice));					
					setTextBold(false);
					setTextColor(1, 1, 1, 1);
					setTextAlignment(0);
					if not fillType.isAnimal and fillType.bestPrices[1] ~= nil then
						if not g_currentMission.hlUtils:disableInArea() and inArea then box:setClickArea( {nextRightPosX-getTextWidth(size, utf8Substr(tostring(bestPrice), 0)), nextRightPosX, nextPosY, nextPosY+box.ownTable.lineHeight, onClick=FTAP_Display_MouseKeyEventsBox.onClickArea, whatClick="FTAP_Display_Box", typPos=boxNumber, whereClick="viewBestPriceStations_", ownTable={fillType.index}} );end;
					end;
					lineWidth = lineWidth-box.ownTable.priceWidth;
					nextRightPosX = nextRightPosX-box.ownTable.priceWidth;
					canNextView = lineWidth > iconWidth;					
				end;
				---fillType Price---
				
				---fillType Amounts+Animals---
				if (box.ownTable.viewFillAmounts or box.ownTable.viewEmptyAmounts) and canNextView then 
					local palAmounts = 0;
					if box.ownTable.viewPal and fillType.pallets.fillLevel ~= nil then palAmounts = Utils.getNoNil(fillType.pallets.fillLevel, 0);end;
					local balesAmounts = 0;
					if box.ownTable.viewBales and fillType.bales.fillLevel ~= nil then balesAmounts = Utils.getNoNil(fillType.bales.fillLevel, 0);end;
					local totalAmount = g_i18n:formatVolume(Utils.getNoNil(fillType.amounts.fillLevel, 0)+palAmounts+balesAmounts, 0);
					if fillType.isAnimal then 
						totalAmount = tostring(fillType.numAnimals);
						if totalAmount:len() > 1 then 
							totalAmount = g_currentMission.hlUtils.getTxtToWidth(tostring(totalAmount), size, lineWidth, true, ".");
						else
							totalAmount = g_currentMission.hlUtils.getTxtToWidth(tostring(totalAmount), size, lineWidth, true, "");
						end;
					else
						totalAmount = g_currentMission.hlUtils.getTxtToWidth(tostring(totalAmount), size, lineWidth, true, ".");
					end;
					
					local canViewPallets = box.ownTable.viewPal and fillType.pallets.fillLevel ~= nil;
					local canViewBales = box.ownTable.viewBales and fillType.bales.fillLevel ~= nil;				
					local canViewStorages = fillType.amounts.storage ~= nil;
					if fillType.viewAmountStorages and ( (fillType.isAnimal and #fillType.animals > 0) or (not fillType.isAnimal and (canViewStorages or canViewPallets or canViewBales)) ) then
						setTextBold(true);
						--set folder Icon is better ?
					else
						setTextBold(false);
					end;					
					if nextRightPosX > nextLeftPosX then
						setTextAlignment(2);
					end;
					setTextColor(unpack(color));
					renderText(nextRightPosX, nextPosY, size, tostring(totalAmount));
					setTextBold(false);
					setTextColor(1, 1, 1, 1);
					setTextAlignment(0);
					if fillType.amounts.storage ~= nil or (fillType.isAnimal and #fillType.animals > 0) or (box.ownTable.viewPal and fillType.pallets.fillLevel ~= nil) or (box.ownTable.viewBales and fillType.bales.fillLevel ~= nil) then
						if not g_currentMission.hlUtils:disableInArea() and inArea then box:setClickArea( {nextRightPosX-getTextWidth(size, utf8Substr(tostring(totalAmount), 0)), nextRightPosX, nextPosY, nextPosY+box.ownTable.lineHeight, onClick=FTAP_Display_MouseKeyEventsBox.onClickArea, whatClick="FTAP_Display_Box", typPos=boxNumber, whereClick="viewAmountStorages_", ownTable={fillType.index}} );end;
					end;					
					nextRightPosX = nextRightPosX-lineWidth;
					lineWidth = lineWidth-box.ownTable.amountWidth;					
					canNextView = lineWidth > iconWidth;					
				end;
				---fillType Amounts+Animals---
				
				---fillType Icon/Name---
				if canNextView then
					local fillTypeName = g_fillTypeManager:getFillTypeNameByIndex(fillType.index);
					overlay = overlayFillTypesGroup[overlayFillTypesByName[fillTypeName]];
					if overlay ~= nil and overlay.subTypeOverlay ~= nil and fillType.isAnimal and fillType.subTypeIndex ~= nil and overlaySubFillTypesGroup[overlay.subTypeOverlay] ~= nil and box.ownTable.viewTypAnimals == 2 then
						overlay = overlaySubFillTypesGroup[overlay.subTypeOverlay];
					end;
					local fillTypeTitle = g_fillTypeManager:getFillTypeTitleByIndex(fillType.index);
					local isCut = FTAP_DisplaySetGet.fillTypes[fillType.index] ~= nil and FTAP_DisplaySetGet.fillTypes[fillType.index].isCut;
					if overlay ~= nil then 
						fillTypeTitle = overlay.title; --with SubType Name					
					end;
					if isCut then fillTypeTitle = fillTypeTitle.. "*";end;
					local fillTypeTitleCut = fillTypeTitle;
					if box.ownTable.viewFillType > 1 then					
						if overlay ~= nil then
							g_currentMission.hlUtils.setOverlay(overlay, nextLeftPosX, nextPosY-difH, iconWidth, iconHeight);
							overlay:render();
							lineWidth = lineWidth-iconWidth;
							canNextView = lineWidth > iconWidth;
						end;
						if box.ownTable.viewFillType == 3 and canNextView then
							fillTypeTitleCut = g_currentMission.hlUtils.getTxtToWidth(fillTypeTitle, size, lineWidth, false, ".");
							setTextColor(unpack(color));
							renderText(nextLeftPosX+iconWidth, nextPosY, size, tostring(fillTypeTitleCut));
							setTextColor(1, 1, 1, 1);							
						end;
					else
						fillTypeTitleCut = g_currentMission.hlUtils.getTxtToWidth(fillTypeTitle, size, lineWidth, false, ".");					
						setTextColor(unpack(color));
						renderText(nextLeftPosX, nextPosY, size, tostring(fillTypeTitleCut));
						setTextColor(1, 1, 1, 1);						
					end;
					if isCurrentPeriod and lineWidth > (iconWidthS*2)+difW then
						overlay = overlayDefaultGroup[overlayDefaultByName["calendar"]];
						if overlay ~= nil then
							local lastWidth = difW;
							if box.ownTable.viewFillType == 1 or box.ownTable.viewFillType == 3 then lastWidth = lastWidth+getTextWidth(size, utf8Substr(tostring(fillTypeTitleCut), 0));end;
							if box.ownTable.viewFillType == 2 or box.ownTable.viewFillType == 3 then lastWidth = lastWidth+iconWidth;end;
							g_currentMission.hlUtils.setOverlay(overlay, nextLeftPosX+lastWidth, nextPosY, iconWidthS, iconHeightS);
							overlay:render();
							if box.isHelp and overlay.mouseInArea() then setInfoHelpText(g_i18n:getText("ui_gameMode_seasonal").. "/".. g_i18n:getText("ui_currently").. "-".. g_i18n:getText("ui_month"));end; 
						end;
					end;
					if not g_currentMission.hlUtils:disableInArea() and inArea then box:setClickArea( {nextLeftPosX, nextLeftPosX+lineWidth, nextPosY, nextPosY+box.ownTable.lineHeight, onClick=FTAP_Display_MouseKeyEventsBox.onClickArea, whatClick="FTAP_Display_Box", typPos=boxNumber, whereClick="fillTypeMarkedDesiredSellPrice_", ownTable={fillType.index}} );end;
				else
					renderText(nextLeftPosX, nextPosY, size, tostring("."));
				end;
				---fillType Icon/Name---				
				
				---fillType viewAmountStorages or viewBestPriceStations or viewAnimalStorages---
				local canViewPallets = box.ownTable.viewPal and fillType.pallets.fillLevel ~= nil;
				local canViewBales = box.ownTable.viewBales and fillType.bales.fillLevel ~= nil;				
				local canViewStorages = fillType.amounts.storage ~= nil;
				if fillType.viewAmountStorages and not fillType.isAnimal and (canViewStorages or canViewPallets or canViewBales) then --viewAmountStorages,pallets,bales
					nextPosY = nextPosY-box.ownTable.lineHeight;
					if nextPosY > y then						
						nextRightPosX = x+w-difW;						
						if canViewPallets and nextPosY > y then --2
							if box.ownTable.viewFillAmounts and fillType.pallets.fillLevel > 0 then
								local tempLineWidth = w-(difW*2)-box.ownTable.amountWidth;
								color = g_currentMission.hlUtils.getColor(box.overlays.color.columTitle, true);
								local objectName = g_i18n:getText("category_pallets").. "(".. tostring(fillType.pallets.total).. ")";
								objectName = g_currentMission.hlUtils.getTxtToWidth("*".. objectName, size, tempLineWidth, false, ".");
								setTextColor(unpack(color));
								renderText(nextLeftPosX, nextPosY, size-difSize, tostring(objectName));
								local palletsAmount = g_i18n:formatVolume(Utils.getNoNil(fillType.pallets.fillLevel, 0), 0);
								palletsAmount = g_currentMission.hlUtils.getTxtToWidth(palletsAmount, size, lineWidth, true, ".");
								if nextRightPosX > nextLeftPosX then
									setTextAlignment(2);
								end;
								renderText(nextRightPosX, nextPosY, size-difSize, tostring(palletsAmount));
								setTextAlignment(0);
								setTextColor(1, 1, 1, 1);
								if not g_currentMission.hlUtils:disableInArea() and inArea then box:setClickArea( {nextLeftPosX, nextRightPosX, nextPosY, nextPosY+box.ownTable.lineHeight, onClick=FTAP_Display_MouseKeyEventsBox.onClickArea, whatClick="FTAP_Display_Box", typPos=boxNumber, whereClick="palletsObject_", ownTable={fillType.index}} );end;
								extraLineBounds = extraLineBounds+1;
								nextPosY = nextPosY-box.ownTable.lineHeight;
							end;
						end;
						if canViewBales and nextPosY > y then --3
							if box.ownTable.viewFillAmounts and fillType.bales.fillLevel > 0 then
								local tempLineWidth = w-(difW*2)-box.ownTable.amountWidth;
								color = g_currentMission.hlUtils.getColor(box.overlays.color.columTitle, true);
								local objectName = g_i18n:getText("category_bales").. "(".. tostring(fillType.bales.total).. ")";
								objectName = g_currentMission.hlUtils.getTxtToWidth("*".. objectName, size, tempLineWidth, false, ".");
								setTextColor(unpack(color));
								renderText(nextLeftPosX, nextPosY, size-difSize, tostring(objectName));
								local balesAmount = g_i18n:formatVolume(Utils.getNoNil(fillType.bales.fillLevel, 0), 0);
								balesAmount = g_currentMission.hlUtils.getTxtToWidth(balesAmount, size, lineWidth, true, ".");
								if nextRightPosX > nextLeftPosX then
									setTextAlignment(2);
								end;
								renderText(nextRightPosX, nextPosY, size-difSize, tostring(balesAmount));
								setTextAlignment(0);
								setTextColor(1, 1, 1, 1);
								if not g_currentMission.hlUtils:disableInArea() and inArea then box:setClickArea( {nextLeftPosX, nextRightPosX, nextPosY, nextPosY+box.ownTable.lineHeight, onClick=FTAP_Display_MouseKeyEventsBox.onClickArea, whatClick="FTAP_Display_Box", typPos=boxNumber, whereClick="balesObject_", ownTable={fillType.index}} );end;
								extraLineBounds = extraLineBounds+1;
								nextPosY = nextPosY-box.ownTable.lineHeight;
							end;
						end;
						if canViewStorages and nextPosY > y then --4							
							for _, storage in pairs(fillType.amounts.storage) do
								local canViewStorage = (box.ownTable.viewFillAmounts and box.ownTable.viewEmptyAmounts) or (box.ownTable.viewFillAmounts and storage.fillLevel > 0) or (box.ownTable.viewEmptyAmounts and storage.fillLevel <= 0);
								if canViewStorage then								
									local tempLineWidth = w-(difW*2)-box.ownTable.amountWidth;
									if storage.fillLevel > 0 then color = g_currentMission.hlUtils.getColor(box.overlays.color.columTitle, true);else color = g_currentMission.hlUtils.getColor(box.overlays.color.notActive, true);end;	
									local moreTxt = "";
									local deliverTxt = "";
									if storage.bales ~= nil and storage.bales > 0 then moreTxt = moreTxt.. "(".. tostring(storage.bales).. "b)";end;
									if storage.pallets ~= nil and storage.pallets > 0 then moreTxt = moreTxt.. "(".. tostring(storage.pallets).. "p)";end;
									local objectName = storage.objectName.. moreTxt;
									objectName = g_currentMission.hlUtils.getTxtToWidth("*".. objectName, size, tempLineWidth, false, ".");
									setTextColor(unpack(color));
									renderText(nextLeftPosX, nextPosY, size-difSize, tostring(objectName));
									if moreTxt:len() > 0 then
										overlay = box.overlays.bgLine; --hidden overlay for area
										if overlay ~= nil then
											g_currentMission.hlUtils.setOverlay(overlay, nextLeftPosX, nextPosY, tempLineWidth, box.ownTable.lineHeight);
											if box.isHelp and overlay.mouseInArea() then setInfoHelpText("..b = ".. g_i18n:getText("ui_amount").. " ".. g_i18n:getText("category_bales").. "\n".. "..p = ".. g_i18n:getText("ui_amount").. " ".. g_i18n:getText("category_pallets"), 0);end;
										end;
									end;
									if storage.production then
										if storage.directDeliver then
											overlay = overlayDefaultGroup[overlayDefaultByName["productionDirectDeliver"]];
											deliverTxt = " - ".. g_i18n:getText("ui_production_output_distributing");
										else
											overlay = overlayDefaultGroup[overlayDefaultByName["production"]];
										end;
										if overlay ~= nil and lineWidth > (iconWidthS*2)+difW then
											g_currentMission.hlUtils.setOverlay(overlay, nextLeftPosX+getTextWidth(size, utf8Substr(tostring(objectName), 0))+difW, nextPosY, iconWidthS, iconHeightS);
											overlay:render();
											if box.isHelp and overlay.mouseInArea() then setInfoHelpText(g_i18n:getText("ui_productions_production").. deliverTxt);end;
										end;
									elseif storage.state ~= nil and (storage.state == BunkerSilo.STATE_CLOSED or storage.state == BunkerSilo.STATE_FERMENTED) then
										overlay = overlayDefaultGroup[overlayDefaultByName["fermenting"]];
										if overlay ~= nil and lineWidth > (iconWidthS*2)+difW then
											g_currentMission.hlUtils.setOverlay(overlay, nextLeftPosX+getTextWidth(size, utf8Substr(tostring(objectName), 0))+difW, nextPosY, iconWidthS, iconHeightS);
											overlay:render();
											local percentTxt = "";
											if storage.percentF ~= nil then percentTxt = " ".. tostring(math.ceil(storage.percentF*100)).. "%";end;
											if box.isHelp and overlay.mouseInArea() then setInfoHelpText(g_i18n:getText("info_fermenting").. percentTxt);end;
										end;
									end;
									local storageAmount = g_i18n:formatVolume(Utils.getNoNil(storage.fillLevel, 0), 0);
									storageAmount = g_currentMission.hlUtils.getTxtToWidth(storageAmount, size, lineWidth, true, ".");
									if nextRightPosX > nextLeftPosX then
										setTextAlignment(2);
									end;
									renderText(nextRightPosX, nextPosY, size-difSize, tostring(storageAmount));
									setTextAlignment(0);
									setTextColor(1, 1, 1, 1);
									if not g_currentMission.hlUtils:disableInArea() and inArea then box:setClickArea( {nextLeftPosX, nextRightPosX, nextPosY, nextPosY+box.ownTable.lineHeight, onClick=FTAP_Display_MouseKeyEventsBox.onClickArea, whatClick="FTAP_Display_Box", typPos=boxNumber, whereClick="storageObject_", ownTable={storage}} );end;
									extraLineBounds = extraLineBounds+1;									
									nextPosY = nextPosY-box.ownTable.lineHeight;
									if nextPosY < y then break;end;
								end;
							end;
						end;						
						setTextColor(1, 1, 1, 1);
						nextPosY = nextPosY+box.ownTable.lineHeight;
					end;
				elseif fillType.viewAmountStorages and fillType.isAnimal and #fillType.animals > 0 then --viewAnimalStorages
					nextPosY = nextPosY-box.ownTable.lineHeight;
					if nextPosY > y then						
						nextRightPosX = x+w-difW;						
						for a=1, #fillType.animals do
							local canViewStorage = (box.ownTable.viewFillAmounts and box.ownTable.viewEmptyAmounts) or (box.ownTable.viewFillAmounts and fillType.numAnimals > 0) or (box.ownTable.viewEmptyAmounts and fillType.numAnimals <= 0);
							if canViewStorage then
								local tempLineWidth = w-(difW*2)-box.ownTable.amountWidth;
								if fillType.animals[a].numAnimals > 0 then color = g_currentMission.hlUtils.getColor(box.overlays.color.columTitle, true);else color = g_currentMission.hlUtils.getColor(box.overlays.color.notActive, true);end;
								local objectName = g_currentMission.hlUtils.getTxtToWidth("*".. fillType.animals[a].objectName, size, tempLineWidth, false, ".");
								setTextColor(unpack(color));
								renderText(nextLeftPosX, nextPosY, size-difSize, tostring(objectName));
								local numAnimals = tostring(fillType.animals[a].numAnimals);
								if numAnimals:len() > 1 then
									numAnimals = g_currentMission.hlUtils.getTxtToWidth(numAnimals, size, lineWidth, true, ".");
								else
									numAnimals = g_currentMission.hlUtils.getTxtToWidth(tostring(numAnimals), size, lineWidth, true, "");
								end;
								if nextRightPosX > nextLeftPosX then
									setTextAlignment(2);
								end;
								renderText(nextRightPosX, nextPosY, size-difSize, tostring(numAnimals));
								setTextAlignment(0);
								setTextColor(1, 1, 1, 1);
								if not g_currentMission.hlUtils:disableInArea() and inArea then box:setClickArea( {nextLeftPosX, nextRightPosX, nextPosY, nextPosY+box.ownTable.lineHeight, onClick=FTAP_Display_MouseKeyEventsBox.onClickArea, whatClick="FTAP_Display_Box", typPos=boxNumber, whereClick="animalObject_", ownTable={fillType.animals[a]}} );end;
								extraLineBounds = extraLineBounds+1;
								nextPosY = nextPosY-box.ownTable.lineHeight;
								if nextPosY < y then break;end;
							end;							
						end;
						setTextColor(1, 1, 1, 1);
						nextPosY = nextPosY+box.ownTable.lineHeight;
					end;
				elseif fillType.viewBestPriceStations and fillType.bestPrices[1] ~= nil then --viewBestPriceStations
					nextPosY = nextPosY-box.ownTable.lineHeight;
					if nextPosY > y then
						nextRightPosX = x+w-difW;						
						if box.ownTable.viewPriceTrend then nextRightPosX = nextRightPosX-iconWidthS;end;						
						if canViewMonthPrice or notFluctuations then
							color = g_currentMission.hlUtils.getColor("yellowGreen", true);							
							local tempLineWidth = w-(difW*2)-box.ownTable.priceWidth;
							local bestMonth = g_i18n:getText("highestPrice").. ": ".. fillType.monthPrices[1].formatMonth;
							if fillType.monthPrices[1].doubleBestMonth then bestMonth = bestMonth.. "/".. fillType.monthPrices[2].formatMonth;end;
							if notFluctuations then	tempLineWidth = w-(difW*2);bestMonth = g_i18n:getText("ui_noFluctuationsForThisFillType");end;
							bestMonth = g_currentMission.hlUtils.getTxtToWidth("-".. bestMonth, size, tempLineWidth, false, ".");							
							--if isCurrentPeriod or fillType.bestPrices[1].price >= fillType.monthPrices[1].price then color = g_currentMission.hlUtils.getColor(box.overlays.color.on, true);end;							
							setTextColor(unpack(color));
							renderText(nextLeftPosX, nextPosY, size-difSize, tostring(bestMonth));
							if canViewMonthPrice then
								local priceMonth = tostring(g_i18n:formatMoney(fillType.monthPrices[1].price, 0, true, false));
								priceMonth = g_currentMission.hlUtils.getTxtToWidth(priceMonth, size, lineWidth, true, ".");
								if nextRightPosX > nextLeftPosX then
									setTextAlignment(2);
								end;
								renderText(nextRightPosX, nextPosY, size-difSize, tostring(priceMonth));
								setTextAlignment(0);
								setTextColor(1, 1, 1, 1);
							end;
							extraLineBounds = extraLineBounds+1;
							nextPosY = nextPosY-box.ownTable.lineHeight;
						end;
						if nextPosY > y then							
							color = g_currentMission.hlUtils.getColor(box.overlays.color.columTitle, true);
							local demandColor = g_currentMission.hlUtils.getColor("ls15", true);
							for _, bestPrice in pairs(fillType.bestPrices) do
								local tempLineWidth = w-(difW*2)-box.ownTable.priceWidth;
								if box.ownTable.viewPriceTrend then								
									overlay = overlayDefaultGroup[overlayDefaultByName["priceTrend".. bestPrice.priceTrend]];
									if overlay ~= nil then
										g_currentMission.hlUtils.setOverlay(overlay, nextRightPosX, nextPosY, iconWidthS, iconHeightS);
										overlay:render();
									end;
								end;
								local stationName = g_currentMission.hlUtils.getTxtToWidth("*".. bestPrice.stationName, size, tempLineWidth, false, ".");
								if isDemand and fillType.greatDemand[1] ~= nil and fillType.greatDemand[1].nodeId == bestPrice.nodeId then
									setTextColor(unpack(demandColor));
								else
									setTextColor(unpack(color));
								end;								
								renderText(nextLeftPosX, nextPosY, size-difSize, tostring(stationName));
								local stationPrice = tostring(g_i18n:formatMoney(bestPrice.price, 0, true, false));
								stationPrice = g_currentMission.hlUtils.getTxtToWidth(stationPrice, size, lineWidth, true, ".");
								if nextRightPosX > nextLeftPosX then
									setTextAlignment(2);
								end;
								setTextColor(unpack(color));
								renderText(nextRightPosX, nextPosY, size-difSize, tostring(stationPrice));
								setTextAlignment(0);
								setTextColor(1, 1, 1, 1);
								if not g_currentMission.hlUtils:disableInArea() and inArea then box:setClickArea( {nextLeftPosX, nextRightPosX, nextPosY, nextPosY+box.ownTable.lineHeight, onClick=FTAP_Display_MouseKeyEventsBox.onClickArea, whatClick="FTAP_Display_Box", typPos=boxNumber, whereClick="bestPriceObject_", ownTable={bestPrice}} );end;
								extraLineBounds = extraLineBounds+1;
								nextPosY = nextPosY-box.ownTable.lineHeight;
								if nextPosY < y then break;end;
							end;
						end;
						setTextColor(1, 1, 1, 1);
						nextPosY = nextPosY+box.ownTable.lineHeight;
					end;
				end;
				---fillType viewAmountStorages or viewBestPriceStations or viewAnimalStorages---
				
				nextPosY = nextPosY-box.ownTable.lineHeight;
				nextRightPosX = x+w-difW;
			elseif #FTAP_DisplaySetGet.viewFillTypes == 0 then
				local moreTxt = "";
				if not box.viewExtraLine and box.searchFilter:len() > 0 then moreTxt = tostring(g_i18n:getText("searchFilter_On"));end;
				local text = g_currentMission.hlUtils.getTxtToWidth(tostring(g_i18n:getText("character_option_none")).. moreTxt, size, w-(difW*2), false, ".");
				setTextColor(unpack(g_currentMission.hlUtils.getColor(box.overlays.color.text, true)));
				renderText(nextLeftPosX, nextPosY, size, tostring(text));
				setTextColor(1, 1, 1, 1);
				break;
			end;
			if extraLineBounds+t >= bounds2 then break;end;
		end;
		box.screen.bounds[4] = box.screen.bounds[4]+extraLineBounds;
	end;	
end;