FTAP_Display_XmlBox = {};

function FTAP_Display_XmlBox:defaultValues(box)
	box.ownTable = {changeViewPrices={0,0}, fillTypes={maps={}}, amountUpdateTimer=1, priceUpdateTimer=5, animalsUpdateTimer=200, palletsUpdateTimer=100, balesUpdateTimer=100, updateList=false, lastStateExtraLine=false, viewPrice=true, viewShowOnPriceTable=false, viewFillAmounts=true, viewEmptyAmounts=true, viewPriceTrend=false, sortBy=1, maxSortBy=6, viewFillType=1, maxViewFillType=3, viewPal=false, viewBales=false, viewAnimals=false, viewTypAnimals=1, viewProductions=false }; --own values viewFillType=1(by Name), 2(by Icon), 3(by Icon/Name)
end;

function FTAP_Display_XmlBox:onLoadXml(box, Xml, xmlNameTag)
	if box.ownTable.viewPrice == nil then FTAP_Display_XmlBox:defaultValues(box);end;	
	if Xml ~= nil and xmlNameTag ~= nil then	
		if getXMLBool(Xml, xmlNameTag.."#viewPrice") ~= nil then 
			box.ownTable.viewPrice = getXMLBool(Xml, xmlNameTag.. "#viewPrice");			
		else
			return; --first config not found
		end;
		if getXMLBool(Xml, xmlNameTag.."#viewShowOnPriceTable") ~= nil then 
			box.ownTable.viewShowOnPriceTable = getXMLBool(Xml, xmlNameTag.. "#viewShowOnPriceTable");			
		end;
		if getXMLBool(Xml, xmlNameTag.."#viewFillAmounts") ~= nil then 
			box.ownTable.viewFillAmounts = getXMLBool(Xml, xmlNameTag.. "#viewFillAmounts");			
		end;
		if getXMLBool(Xml, xmlNameTag.."#viewEmptyAmounts") ~= nil then 
			box.ownTable.viewEmptyAmounts = getXMLBool(Xml, xmlNameTag.. "#viewEmptyAmounts");			
		end;
		if getXMLBool(Xml, xmlNameTag.."#viewPriceTrend") ~= nil then 
			box.ownTable.viewPriceTrend = getXMLBool(Xml, xmlNameTag.. "#viewPriceTrend");
		end;
		if getXMLBool(Xml, xmlNameTag.."#viewPal") ~= nil then 
			box.ownTable.viewPal = getXMLBool(Xml, xmlNameTag.. "#viewPal");
		end;
		if getXMLBool(Xml, xmlNameTag.."#viewBales") ~= nil then 
			box.ownTable.viewBales = getXMLBool(Xml, xmlNameTag.. "#viewBales");
		end;		
		if getXMLBool(Xml, xmlNameTag.."#viewAnimals") ~= nil then 
			box.ownTable.viewAnimals = getXMLBool(Xml, xmlNameTag.. "#viewAnimals");
		end;
		if getXMLInt(Xml, xmlNameTag.."#viewTypAnimals") ~= nil then 
			box.ownTable.viewTypAnimals = getXMLInt(Xml, xmlNameTag.. "#viewTypAnimals");
		end;
		if getXMLBool(Xml, xmlNameTag.."#viewProductions") ~= nil then 
			box.ownTable.viewProductions = getXMLBool(Xml, xmlNameTag.. "#viewProductions");
		end;		
		if getXMLInt(Xml, xmlNameTag.."#viewFillType") ~= nil then 
			box.ownTable.viewFillType = getXMLInt(Xml, xmlNameTag.. "#viewFillType");
		end;
		if getXMLInt(Xml, xmlNameTag.."#sortBy") ~= nil then 
			box.ownTable.sortBy = getXMLInt(Xml, xmlNameTag.. "#sortBy");
		end;
		local groupNameTag = (xmlNameTag.. ".updateTimersSec(%d)"):format(0);
		if getXMLInt(Xml, groupNameTag.."#balesTimer") ~= nil then 
			box.ownTable.balesUpdateTimer = getXMLInt(Xml, groupNameTag.. "#balesTimer");
		end;
		if getXMLInt(Xml, groupNameTag.."#palletsTimer") ~= nil then 
			box.ownTable.palletsUpdateTimer = getXMLInt(Xml, groupNameTag.. "#palletsTimer");
		end;
		if getXMLInt(Xml, groupNameTag.."#animalsTimer") ~= nil then 
			box.ownTable.animalsUpdateTimer = getXMLInt(Xml, groupNameTag.. "#animalsTimer");
		end;
		if getXMLInt(Xml, groupNameTag.."#priceTimer") ~= nil then 
			box.ownTable.priceUpdateTimer = getXMLInt(Xml, groupNameTag.. "#priceTimer");
		end;
		if getXMLInt(Xml, groupNameTag.."#amountTimer") ~= nil then 
			box.ownTable.amountUpdateTimer = getXMLInt(Xml, groupNameTag.. "#amountTimer");
		end;
		--marked fillTypes--
		local groupNameTag = (xmlNameTag.. ".maps(%d)"):format(0);
		local int = 0;		
		while true do
			local mapGroupNameTag = (groupNameTag.. ".map(%d)"):format(int);
			if mapGroupNameTag == nil or getXMLString(Xml, mapGroupNameTag.. "#name") == nil or not getXMLString(Xml, mapGroupNameTag.. "#name") or int > 50 then break;else
				local found = true;
				local mapId = getXMLString(Xml, mapGroupNameTag.. "#name");
				if box.ownTable.fillTypes.maps[mapId] == nil then box.ownTable.fillTypes.maps[mapId] = {marked={},desiredSellPrice={}};end;
				if getXMLString(Xml, mapGroupNameTag.. "#marked_fillTypes") ~= nil then
					local fillTypesString = getXMLString(Xml, mapGroupNameTag.. "#marked_fillTypes");
					if fillTypesString:len() > 0 then
						local stringSplit = g_currentMission.hlUtils.stringSplit(fillTypesString, " ");
						for a=1, #stringSplit do
							if box.ownTable.fillTypes.maps[mapId].marked[stringSplit[a]] == nil then box.ownTable.fillTypes.maps[mapId].marked[stringSplit[a]] = true;end;
						end;
					else
						found = false;
					end;
				else
					found = false;
				end;
				if not found then box.ownTable.fillTypes.maps[mapId] = nil;end;
				int = int+1;
			end;
		end;
		--marked fillTypes--		
	end;	
end;

function FTAP_Display_XmlBox.onSaveXml(box, Xml, xmlNameTag)
	setXMLInt(Xml, xmlNameTag.."#version", FTAP_Display.metadata.xmlVersion);
	setXMLBool(Xml, xmlNameTag.."#viewPrice", box.ownTable.viewPrice);
	setXMLBool(Xml, xmlNameTag.."#viewShowOnPriceTable", box.ownTable.viewShowOnPriceTable);
	setXMLBool(Xml, xmlNameTag.."#viewFillAmounts", box.ownTable.viewFillAmounts);
	setXMLBool(Xml, xmlNameTag.."#viewEmptyAmounts", box.ownTable.viewEmptyAmounts);
	setXMLBool(Xml, xmlNameTag.."#viewPriceTrend", box.ownTable.viewPriceTrend);
	setXMLBool(Xml, xmlNameTag.."#viewPal", box.ownTable.viewPal);
	setXMLBool(Xml, xmlNameTag.."#viewBales", box.ownTable.viewBales);	
	setXMLBool(Xml, xmlNameTag.."#viewAnimals", box.ownTable.viewAnimals);
	setXMLInt(Xml, xmlNameTag.."#viewTypAnimals", box.ownTable.viewTypAnimals);
	setXMLBool(Xml, xmlNameTag.."#viewProductions", box.ownTable.viewProductions);	
	setXMLInt(Xml, xmlNameTag.."#viewFillType", box.ownTable.viewFillType);
	setXMLInt(Xml, xmlNameTag.."#sortBy", box.ownTable.sortBy);
	local groupNameTag = (xmlNameTag.. ".updateTimersSec(%d)"):format(0);
	setXMLInt(Xml, groupNameTag.."#balesTimer", box.ownTable.balesUpdateTimer);
	setXMLInt(Xml, groupNameTag.."#palletsTimer", box.ownTable.palletsUpdateTimer);
	setXMLInt(Xml, groupNameTag.."#animalsTimer", box.ownTable.animalsUpdateTimer);
	setXMLInt(Xml, groupNameTag.."#priceTimer", box.ownTable.priceUpdateTimer);
	setXMLInt(Xml, groupNameTag.."#amountTimer", box.ownTable.amountUpdateTimer);
	--marked fillTypes--
	local groupNameTag = (xmlNameTag.. ".maps(%d)"):format(0);	
	local int = 0;
	for mapId, value in pairs(box.ownTable.fillTypes.maps) do
		local mapGroupNameTag = (groupNameTag.. ".map(%d)"):format(int);		
		local fillTypesString = "";
		for name, _ in pairs(value.marked) do
			if fillTypesString:len() > 0 then 
				fillTypesString = fillTypesString.. " ".. tostring(name);
			else
				fillTypesString = tostring(name);
			end;
		end;
		if fillTypesString:len() > 0 then
			setXMLString(Xml, mapGroupNameTag.. "#name", tostring(mapId));
			setXMLString(Xml, mapGroupNameTag.."#marked_fillTypes", tostring(fillTypesString));
		end;
		int = int+1;
	end;
	--marked fillTypes--
end;

function FTAP_Display_XmlBox:loadBox(name, onSave)
	if name == "FTAP_Display_Box" then
		local box = g_currentMission.hlHudSystem.hlBox.generate( {name=name, width=250, height=150, info="FillTypeAmountPrice Display Mod\nFTAP Box (FillTypeAmountPrice)", autoZoomOutIn="text", hiddenMod="FillTypeAmountPriceDisplay"} );
		FTAP_DisplaySetGet:loadBoxIcons(box);
		box:setMinWidth(box.screen.pixelW*80); --set min. width new (default ..pixelW*30)
		box.onDraw = FTAP_Display_DrawBox.setBox;
		box.onClick = FTAP_Display_MouseKeyEventsBox.onClick;							
		box.screen.canBounds.on = true;
		box.resetBoundsByDragDrop = false;
		box.overlays.settingIcons.up.visible = true; --for viewExtraLine
		box.overlays.settingIcons.down.visible = true; --for viewExtraLine
		box.overlays.settingIcons.save.visible = true; --save over global icon
		box.isHelp = true;
		box.onSaveXml = FTAP_Display_XmlBox.onSaveXml;						
		FTAP_Display_XmlBox:onLoadXml(box, box:getXml()); --own box load over Xml (replace Data)
		FTAP_DisplaySetGet:loadFillTypes(box);									
		if onSave == nil or not onSave then box.viewExtraLine = true;box.ownTable.lastStateExtraLine = true;end;
		if onSave == nil or box.show then
			--first start updates--
			FTAP_DisplaySetGet:setFillTypesPrice(); --first start
			FTAP_DisplaySetGet:setFillTypesAmount(); --first start
			if box.ownTable.viewAnimals then FTAP_DisplaySetGet:setNumOfAnimals();end;
			if box.ownTable.viewBales then FTAP_DisplaySetGet:setBalesAmount();end;
			if box.ownTable.viewPal then FTAP_DisplaySetGet:setPalletsAmount();end;									
			--first start updates--
		end;
	end;
end;